	subroutine physp(unit,n,v,nmax,vinv,imax,eps)
	implicit real*8(a-h,o-z)
	dimension v(nmax,n),e(n),vec(n,n),vinv(imax,n)
	logical unit
c
c	Find vinv = v, omitting zero eigenvalues
c		e and vec are temporary storage only.
c
	call F02ABF(v,nmax,n,e,vec,n,vinv,info)

	do 2 i=1,n
	do 2 j=1,n
2	vinv(i,j) = 0d0

	if(unit) then
	do 5 i=1,n
5	vinv(i,i) = 1d0
	else
	do 20 k=1,n
	write(6,*) 'WN1 eigenvalue ',real(e(k))
	 if(abs(e(k)).lt.eps) go to 20
	 do 16 i=1,n
	 do 16 j=1,n
16	 vinv(i,j) = vinv(i,j) + vec(i,k) * vec(j,k)
20	 continue
	endif
	return
	end
	subroutine tnbasis(n,wn1,mchan,ctn,nctn,dtn,ndtn,thresh,nb)
	implicit real*8(a-h,o-z)
	dimension wn1(mchan,n),ctn(nctn,n),null(n),dtn(ndtn,n),
     X		  work(n,n)
        PARAMETER ( ZERO=0.0D0,ONE=1.D0)

************  Construct orthonormal basis by Gramm-Schmidt,
************  using norm matrix wn1
************  put new basis in *columns* of ctn
	nu = 0
	nb = 0
	do 100 i=1,n
	 do 10 k=1,n
10	 ctn(k,i)  = ZERO
	 ctn(i,i) = ONE
c			Subtract overlaps with previous basis states:
	 do 30 k=1,n
	   x1 = ZERO
	 do 20 j=1,nb
	   xo = ZERO
	   do 15 m=1,n
15	   xo = xo + wn1(m,i)*ctn(m,j)
20	   x1 = x1 + xo * ctn(k,j)
30	  ctn(k,i) = ctn(k,i) - x1
c
c			Find norm of orthogonalised state:
	 xn = ZERO
	 do 40 ip=1,n
	 do 40 iq=1,n
40	 xn = xn + ctn(ip,i)*wn1(ip,iq)*ctn(iq,i)
c	write(6,*) 'Orthogonalised TN state',i,' has norm',real(xn),
c    x			' -> ',nb+1
	if(abs(xn).lt.thresh)  then
		nu = nu+1
		null(nu) = i
		go to 100
	    endif
	xn = ONE/sqrt(xn)
	nb = nb+1
c			Normalise if possible, and copy into next slot.
	do 50 k=1,n
50	ctn(k,nb) = ctn(k,i) * xn
100	continue
	 if(nb.ne.n) 
     x	 write(6,*) ' Only ',nb,' linearly independent channels'
c			Fill up column vectors with units on null rows
	do 120 i=nb+1,n
	 do 110 k=1,n
110	 ctn(k,i) = ZERO
120	 ctn(null(i-nb),i) = ONE

c 	Now find inverse transformation:  dtn = ctn* . wn1
	 call dgemm ('t','n',n,n,n,ONE,ctn,nctn,wn1,mchan,
     X			ZERO,dtn,ndtn)

	return
 1100 format (' tnbasis : error return from dgetrf, info = ',i6)
 1110 format (' tnbasis : error return from dgetrs, info = ',i6)
	end
