      subroutine asywfn (nchan,nmax,iasy,f,fp,eps,nfc,ipflg,
     x                   iasx,j,lj,rafin,skj,etj,etaj,jopen,
     x			 ga1,ga2,ierfg,ae)
*
* $Id: asywfn.f,v 1.1 93/04/22 14:27:12 vmb Exp Locker: vmb $
*
	use globals, only: cf,potcoef,npots,ipmax
      implicit integer (a-z)
      logical jopen
      real*8 f,fp,fc,fcp,gc,gcp,eps,xg,xc,xd,rafin,skj,etj,etaj,ga1,
     x	     ga2,rscalx,zero,rho,flj,f1,g1,fp1,gp1,xi,del1,del2,
     x	     del3,del4,del,delp,dr1,dpr1,dr2,dpr2,aerr1,aerr2,aepr1,
     x	     aepr2,zz,u,uder,xcp,xdp,fp2,gp2,fdd,one,two,dr1p,
     x       dr2p,dpr1p,dpr2p,scalx,ae,cfp
      parameter ( zero=0.0d0,one=1.0d0,two=2.0d0 )
      dimension fc(nfc),gc(nfc),fcp(nfc),gcp(nfc),ga1(nmax,0:iasy),
     x		f(nchan,nchan,2),fp(nchan,nchan,2),ga2(nmax,0:iasy),
     x		xg(0:iasy),xc(0:iasx),xd(0:iasx),xcp(0:iasx),
     x		xdp(0:iasx)
      common /io/ iin,iout
      common /mach/ scalx,rscalx
      real*8 scent,ryev,fl0,fllj,escat
      common /cent/ scent,ryev
      common /ie/ escat,ierr
*
*     asywfn : asymptotic scattering functions, f, and derivatives, fp.
*
      rho = rafin * skj
      flj = (lj) + scent
      fl0 = flj - int(flj)
      fllj = flj * ( flj + 1 )
	lj1 = 1 + scent
      if ( jopen ) then
	 call coulfg (rho,etaj,fl0,flj,fc,gc,fcp,gcp,1,0,ifail,m1)
         if (ifail .lt. 0) then
	    write (iout,1000) ifail,lj,rho,etaj
	 else if (ifail .gt. 0) then
	    write (99,1000) ifail,lj,rho,etaj
	    fc(lj+lj1)=fc(lj+lj1-ifail)
	    gc(lj+lj1)=gc(lj+lj1-ifail)
	    fcp(lj+lj1)=fcp(lj+lj1-ifail)
	    gcp(lj+lj1)=gcp(lj+lj1-ifail)
         end if
	 f1 = fc(lj+lj1) 
	 g1 = gc(lj+lj1)
	 fp1 = fcp(lj+lj1)
	 gp1 = gcp(lj+lj1)
	 fdd = ( fllj / rho + two * etaj ) / rho - one
         fp2 = fdd * f1
         gp2 = fdd * g1
	 if ( ipflg .eq. 1 ) then
	    write (iout,1000) ifail,lj,rho,etaj
	    write (iout,1010) rafin,skj,f1,g1,fp1,gp1
	 endif
      else
	 cfp = 0d0
	  do np=1,npots
	    cfp = cfp + cf(j,j,1,np) * potcoef(np)
   	  enddo
	 zz = -cfp*0.5d0
	    call coul (flj,zz,etj,rafin,u,uder)
	 f1 = u 
	 fp1 = uder 
	 fp2 = ((fllj / rho + two * etaj) / rho + one) * skj *
     x         skj * f1
	 if ( ipflg .eq. 1 ) write (iout,1020) lj,cfp,rafin,etj,skj,f1,
     x					       fp1
      endif
*     evaluate asymptotic series
      xi = one / rafin
	ae = zero
      do 320 i = 1, nchan
	 ily = 0
	 ilz = 0
	 do 220 p = 0, iasy
	    if ( abs(ga1(i,p)) .le. scalx * 1.0d-6) ily = p
	    if ( abs(ga2(i,p)) .le. scalx * 1.0d-6) ilz = p
  220	 continue
	 ily1 = ily + 1
         ilym = ily - 1
	 if ( ily .eq. iasy ) then
	    dr1 = zero
	    dpr1 = zero
            aerr1 = zero
            aepr1 = zero
	 elseif ( ily .lt. iasy ) then
	    ncfct = iasy - ily1
	    if ( ipflg .ne. 0 ) write (iout,1030) ily1,iasy
	    do 240 ip1 = ily1, iasy
	       xg(ip1-ily1) = ga1(i,ip1)
  240	    continue
	    np = ( ncfct + 1 ) / 2
	    call rrfr (ncfct,np,xg,xc,xcp,xd,xdp)
	    call rrfvl (np,ily1,xi,xc,xd,xcp,xdp,dr1,dpr1,aerr1,aepr1,
     x			ierfg)
	 endif
	 ilz1 = ilz + 1
         ilzm = ilz - 1
	 if ( ilz .eq. iasy ) then
	    dr2 = zero
	    dpr2 = zero
            aerr2 = zero
            aepr2 = zero
	 elseif ( ilz .lt. iasy ) then
	    ncfct = iasy - ilz1
	    if ( ipflg .ne. 0 ) write (iout,1030) ilz1,iasy
	    do 245 ip1 = ilz1, iasy
	       xg(ip1-ilz1) = ga2(i,ip1)
  245	    continue
	    np = ( ncfct + 1 ) / 2
	    call rrfr (ncfct,np,xg,xc,xcp,xd,xdp)
	    call rrfvl (np,ilz1,xi,xc,xd,xcp,xdp,dr2,dpr2,aerr2,aepr2,
     x			ierfg)
	 endif
	 if ( ily .ge. 1 ) then
	    call rpolq (ga1,xi,dr1p,dpr1p,ilym,nmax,i)
	    dr1 = dr1 + dr1p
	    dpr1 = dpr1 + dpr1p
	 endif
	 if ( ilz .ge. 1 ) then
	    call rpolq (ga2,xi,dr2p,dpr2p,ilzm,nmax,i)
	    dr2 = dr2 + dr2p
	    dpr2 = dpr2 + dpr2p
	 endif
*     asymptotic functions and errors
	 if ( jopen ) then
	    f(i,j,1) = rscalx * ( f1 * dr1 + fp1 * dr2 )
	    fp(i,j,1) = rscalx * ( skj * fp1 * dr1 + f1 * dpr1 + skj *
     x			fp2 * dr2 + fp1 * dpr2 )
	    f(i,j,2) = rscalx * ( g1 * dr1 + gp1 * dr2 )
	    fp(i,j,2) = rscalx * ( skj * gp1 * dr1 + g1 * dpr1 + skj *
     x			gp2 * dr2 + gp1 * dpr2 )
	    if ( ierfg .ne. 0 ) then
	       del1 = abs( rscalx * ( f1 * aerr1 + fp1 * aerr2 ) )
	       del2 = abs( rscalx * ( skj * fp1 * aerr1 + f1 * aepr1 +
     x		      skj * fp2 * aerr2 + fp1 * aepr2 ) )
	       del = max( del1, del2 )
		ae = max(ae,del)
	       if ( del .gt. eps .and. ipflg .ne. 0 ) then
		  call galerr (i,j,f(i,j,1),del1,fp(i,j,1),del2)
	       endif
	       del3 = abs( rscalx * ( g1 * aerr1 + gp1 * aerr2 ) )
	       del4 = abs( rscalx * ( skj * gp1 * aerr1 + g1 * aepr1 +
     x		      skj * gp2 * aerr2 + gp1 * aepr2 ) )
	       delp = max( del3, del4 )
		ae = max(ae,delp)
	       if ( delp .gt. eps .and. ipflg .ne. 0 ) then
		  call galerr (i,j,f(i,j,2),del3,fp(i,j,2),del4)
	       endif
c		write(790,250) escat,del1,del2,del3,del4,i,j
c250		format(f10.5,1p,4g12.4,2i3)
	    endif
	 else
	    f(i,j,1) = rscalx * ( f1 * dr1 - fp1 * dr2 / skj )
	    fp(i,j,1) = rscalx * ( fp1 * dr1 + f1 * dpr1 - ( fp2 *
     x			dr2 + fp1 * dpr2 ) / skj )
	    if ( ierfg .ne. 0 ) then
	       del1 = abs( rscalx * ( f1 * aerr1 - fp1 * aerr2 / skj ) )
	       del2 = abs( rscalx * ( fp1 * aerr1 + f1 * aepr1 - ( fp2 *
     x		      aerr2 + fp1 * aepr2 ) / skj ) )
	       del = max( del1, del2 )
		ae = max(ae,del)
	       if ( del .gt. eps .and. ipflg .ne. 0 ) then
		  call galerr (i,j,f(i,j,1),del1,fp(i,j,1),del2)
	       endif
	    endif
	 endif
  320 continue
      return
*
 1000 format (' coulfg : ifail =',i4,' lj =',i4,' rho =',d16.8,
     x        ' etaj =',d16.8)
 1010 format (' rafin =',f12.5,' skj =',d16.8,' f =',d16.8,' g =',d16.8,
     x	      /,' fp =',d16.8,' gp =',d16.8)
 1020 format (' coul/decay : lj =',i3,' etap =',i3,' rafin =',d16.8,
     x	      ' etj =',d16.8,' skj =',f12.5,/,14x,' f1 =',d16.8,
     x	      ' dp1 =',d16.8)
 1030 format (' coefficients',i3,' to',i3,' extrapolated ')
      end
      subroutine gail2 (j,skj,etaj,et,l2p,nchan,cf,mchan,numax,jopen,
     x			iasy,ga,gb,degeny,gmax,ipflg)
*
* $Id: gail2.f,v 1.1 93/04/22 14:27:23 vmb Exp Locker: vmb $
*
	use gailitis, only: nulim
	use globals, only: npots,potcoef,ipmax
      implicit integer (a-z)
      logical jopen
      real*8 skj,etaj,et,cf,degeny,zero,etj,ga,gb,sma,smb,sgn,
     x       fac1,fac2,fac3,fac4,save,two,dena,gmax,one,fp1,fp2,
     x       fp12,scalx,rscalx,iac1,cfp
      parameter ( zero=0.0d0,one=1.0d0,two=2.0d0 )
      dimension et(nchan),l2p(nchan),cf(mchan,mchan,ipmax,npots),
     x          ga(nchan,0:iasy+1),gb(nchan,0:iasy+1),fac1(nchan),
     x          fac2(nchan),fac3(nchan),fac4(nchan),iac1(nchan),
     x          deg(nchan),sma(nchan),smb(nchan)
      common /io/ iin,iout
      common /mach/ scalx,rscalx
      real*8 scent,ryev,flj,fllj
      common /cent/ scent,ryev
*
      iasy1 = iasy + 1 
      etj = et(j)
      flj = l2p(j) + scent
      fllj = flj * ( flj + 1 )
	if(ipflg.ge.1) then
	write(iout,*) 'Gail2: iasy,numax =',iasy,numax
	write(iout,*) 'Gail2: j,etj*ryev,flj =',j,real(etj*ryev),real(flj)
	endif
      sgn = one
      if (.not.jopen) sgn = - sgn
      do 800 i = 1, nchan
            fac2(i) = two * skj
            iac1(i) = fllj - (l2p(i)+scent) * ( l2p(i) + 1 + scent) 
            fac3(i) = two * etaj
            fac4(i) = two * fllj / skj
            ga(i,0) = zero
            ga(i,1) = zero
            gb(i,0) = zero
            gb(i,2) = zero    
	 	cfp = 0d0
		if(numax>=2) then
	  	do np=1,npots
	    	 cfp = cfp + cf(i,j,2,np) * potcoef(np)
   	  	enddo
		endif
         if ( abs(et(i)-etj) .gt. degeny ) then
            fac1(i) = one / ( et(i) - etj )
            deg(i) = 0
            ga(i,2) = scalx * fac1(i) * cfp
            gb(i,1) = zero
         else
            deg(i) = 1
            gb(i,1) = scalx * cfp / fac2(i)
         endif
  800 continue
      ga(j,0) = scalx
      do 500 p = 3, iasy1
         p1 = p - 1
         p2 = p - 2
         p12 = p1 * p2
         fp1 = (p1)
         fp2 = (p2)
         fp12 = (p1 + p2)
         do 300 m = 1, nchan
            sma(m) = zero
            smb(m) = zero
            save = p12 + iac1(m)
            gb(m,p) = - save * gb(m,p2)
            ga(m,p) =  - save * ga(m,p2) + fac3(m) * sgn *
     x                  fp12 * gb(m,p2) + sgn * fac4(m) * 
     x                  fp2 * gb(m,p-3)
  300    continue
c	nulim=numax
            nux = min( numax, p ,nulim)
            do 35 nu = 2,nux
            do 35 np = 1,npots
               call dgemv('n',nchan,nchan,potcoef(np),cf(1,1,nu,np),
     x                    mchan,ga(1,p-nu),1,one,sma,1)
               call dgemv('n',nchan,nchan,potcoef(np),cf(1,1,nu,np),
     x                    mchan,gb(1,p-nu),1,one,smb,1)
 35         continue
         do 45 m = 1,nchan
            if ( deg(m) .eq. 1 ) then
               dena = one / (fac2(m) * fp1)
               ga(m,p1) = -sgn * (gb(m,p) + smb(m)) * dena
               gb(m,p1) = (ga(m,p) + sma(m)) * dena 
            else
               dena = fac2(m) * fp1
               ga(m,p) = (ga(m,p) + sma(m) - dena * gb(m,p1))*fac1(m)
               gb(m,p) = (gb(m,p) + smb(m) + sgn * dena *
     x                   ga(m,p1)) * fac1(m) 
            end if     
             gmax = max(abs(ga(m,p1)),abs(gb(m,p1)),gmax)
45      continue
         if ( gmax .gt. rscalx ) then
            p2 = (p2/2) * 2
            write (iout,1050) p2
            stop
         endif
  500 continue
      return
*
 1050 format (' gail2 : scaling overflow, set iasy =',i3)
      end
      subroutine gailco (nchan,ipflg,et,l2p,cf,mchan,numax,
     x                   iasy,degeny,gmax)
*
* $Id: gailco.f,v 1.1 93/04/22 14:27:26 vmb Exp Locker: vmb $
*
	use gailitis
	use globals, only: npots,potcoef
      implicit integer (a-z)
      logical jopen
      real*8 et,cf,degeny,zero,etj,skj,etaj,gmax,cfp
      parameter ( zero=0.0d0 )
      dimension et(nchan),ipflg(4),l2p(nchan),
     X		cf(mchan,mchan,numax,npots)
*
	if(allocated(gaa)) deallocate(gaa)
	if(allocated(gba)) deallocate(gba)
	allocate(gaa(nchan,iasy+1,nchan),gba(nchan,iasy+1,nchan))
      iasy1 = iasy - 1
      gmax = zero
      do 80 j = 1, nchan
         etj = et(j)
         skj = sqrt(abs(etj))
	 	cfp = 0d0
	  	do np=1,npots
	    	 cfp = cfp + cf(j,j,1,np) * potcoef(np)
   	  	enddo
         etaj = cfp / (skj+skj)
         jopen = etj .ge. zero
         call gail2 (j,skj,etaj,et,l2p,nchan,cf,mchan,numax,jopen,iasy1,
     x	             gaa(1,1,j),gba(1,1,j),degeny,gmax,ipflg(1))
   80 continue
*     print expansion coefficients if ipflg=1
*
      if (ipflg(1) .ne. 0) then
         do 90 j = 1, max(min(nchan,5),nchan/10)
            call prgail (j,nchan,iasy1,gaa(1,1,j),gba(1,1,j))
 90      continue
      end if
      return
      end
      subroutine gailit (f,fp,nchan,nmax,ipflg,rafin,et,l2p,
     x                   iasy,eps,lmax,aer)
*
* $Id: gailit.f,v 1.1 93/04/22 14:27:30 vmb Exp Locker: vmb $
*
	use gailitis
	use globals, only: cf,potcoef,npots
      implicit integer (a-z)
      logical jopen
      real*8 f,fp,rafin,et,eps,zero,etj,skj,
     x       etaj,aer,aerj,cfp
      parameter ( zero=0.0d0 )
      dimension f(nchan,nchan,2),fp(nchan,nchan,2),et(nmax),ipflg(4),
     x          l2p(nmax)
*
      nfc = lmax + 10
      iasx = iasy / 2
      iasy1 = iasy - 1
      do 50 jdd = 1, nchan
         do 40 idd = 1, nchan
            f(idd,jdd,1) = zero
            fp(idd,jdd,1) = zero
            f(idd,jdd,2) = zero
            fp(idd,jdd,2) = zero
   40    continue
   50 continue
	aer = zero
      do 80 j = 1, nchan
         jchan = j
         lj = l2p(j)
         etj = et(j)
         skj = sqrt(abs(etj))
	 	cfp = 0d0
	  	do np=1,npots
	    	 cfp = cfp + cf(j,j,1,np) * potcoef(np)
   	  	enddo
         etaj = cfp / (skj+skj)
         jopen = etj .ge. zero
         call asywfn (nchan,nmax,iasy1,f,fp,eps,nfc,ipflg(3),
     x                iasx,jchan,lj,rafin,skj,etj,etaj,jopen,
     x                gaa(1,1,j),gba(1,1,j),ipflg(4),aerj)
	 aer = max(aer,aerj)
   80 continue
      return
      end
      subroutine galerr (i,j,f1,d1,fp1,dp1)
*
* $Id: galerr.f,v 1.1 93/04/22 14:27:33 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 f1,fp1,d1,dp1,escat,e
      common /ie/ escat,ierr
*
      if ( ierr .ne. 0 ) then
         e = escat
         write (3,1000) e,i,j,f1,d1,fp1,dp1
      endif
      return
 1000 format (' galerr: e =',f9.5,' ij =',2i3,' f =',f10.6,
     x        ' (',1p,e7.1,0p,') fp =',f10.6,' (',1p,e7.1,')')
      end
      subroutine prgail (j,nchan,iasy,ga,gb)
*
* $Id: prgail.f,v 1.1 93/04/22 14:27:57 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 ga,gb
      dimension ga(nchan,0:iasy+1),gb(nchan,0:iasy+1)
      common /io/ iin,iout
*
*     print expansion coefficients if ipflg=1
*
      write (iout,1010) j
      write (iout,1020)
      write (iout,1030)
      do 260 i = 0, iasy
	 write (iout,1050) i
	 write (iout,1000) (ga(jj,i),jj = 1,nchan)
  260 continue
      write (iout,1040)
      do 270 i = 0, iasy
	 write (iout,1050) i
	 write (iout,1000) (gb(jj,i),jj = 1,nchan)
  270 continue
*
 1000 format (1x,5d14.6)
 1010 format (' expansion coefficients with j= ',i2)
 1020 format (1x,33('-'))
 1030 format (' gailitis a-coefficients :')
 1040 format (' gailitis b-coefficients :')
 1050 format (' term =',i4)
      return
      end
      subroutine rpolp (cr,zr,sr,srp,n)
*
* $Id: rpolp.f,v 1.1 93/04/22 14:27:41 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 cr,zr,sr,srp
      dimension cr(0:n)
*
*     evaluate power series and derivative, coefficients cr, 
*     argument 1/zr, results in sr and srp
*
      sr = cr(n)
      srp = (n) * sr
      do 10 i = n-1, 0, -1
	 sr = sr * zr + cr(i)
         srp = srp * zr + (i) * cr(i)
   10 continue
      srp = - srp * zr
      return
      end
      subroutine rpolpp (cr,zr,sr,srp,n,np)
*
* $Id: rpolpp.f,v 1.1 93/04/22 14:27:44 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 cr,zr,sr,srp,srq
      dimension cr(0:n)
*
*     evaluate power series and derivative, coefficients cr, 
*     argument 1/zr, results in sr and srp
*     leading inverse power of np
*
      sr = cr(n)
      srp = (np+n) * sr
      do 10 i = n-1, 0, -1
	 sr = sr * zr + cr(i)
         srp = srp * zr + (np+i) * cr(i)
   10 continue
      srq = zr**np
      sr = srq * sr
      srp = - srq * srp * zr
      return
      end
      subroutine rpolq (cr,zr,sr,srp,n,m,m1)
*
* $Id: rpolq.f,v 1.1 93/04/22 14:27:47 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 cr,zr,sr,srp
      dimension cr(m,0:n)
*
*     evaluate power series and derivative, coefficients cr, 
*     argument zr, results in sr and srp
*
      sr = cr(m1,n)
      srp = (n) * sr
      do 10 i = n-1, 0, -1
	 sr = sr * zr + cr(m1,i)
         srp = srp * zr + (i) * cr(m1,i)
   10 continue
      srp = - zr * srp
      return
      end
      subroutine rrfr (n,np,g,c,cp,d,dp)
*
* $Id: rrfr.f,v 1.1 93/04/22 14:27:49 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 one,zero,ak,c,ci,cp,ct,d,dd,di,dn,dp,dt,g
      parameter ( zero=0.0d0,one=1.0d0 )
      dimension g(0:n),c(0:np),cp(0:np),d(0:np),dp(0:np)
*
*     rrfr : converts polynomial g to a rational fraction
*	       g    = vector g(k), k=0,n
*	       c,cp = numerator polynomials, convergents n and n-1
*	       d,dp = denominator polynomials, convergents n and n-1
*
      do 10  i = 1, np
	 c(i) = zero
	 cp(i) = zero
	 d(i) = zero
	 dp(i) = zero
   10 continue
      c(0) = g(0)
      cp(0) = g(0)
      d(0) = one
      dp(0) = one
      ct = zero
      dt = one
      dn = g(0)
      do 40 k = 1, n
	 dd = dn
	 dn = zero
	 nq = ( k + 1 ) / 2
c$dir scalar
	 do 20 i = 0, nq
	    dn = dn + g(k-i) * d(i)
   20	 continue
	 ak = - dn / dd
	 if ( ak .eq. zero ) return
	 do 30 i = 1, nq
	    ci = c(i)
	    c(i) = ci + ak * ct
	    ct = cp(i)
	    cp(i) = ci
	    di = d(i)
	    d(i) = di + ak * dt
	    dt = dp(i)
	    dp(i) = di
   30	 continue
	 ct = g(0)
	 dt = one
   40 continue
      return
      end
      subroutine rrfvl (nt,ip,xi,xc,xd,xcp,xdp,dr,dpr,aerr,aepr,ierr)
*
* $Id: rrfvl.f,v 1.1 93/04/22 14:27:54 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 xi,xc,xd,xcp,xdp,dr,dpr,aerr,aepr,csr,cspr,dsr,dspr,
     x       dr1,dpr1
      dimension xc(0:nt),xd(0:nt),xcp(0:nt),xdp(0:nt)
*
*     rrfvl : evaluates real rational fraction
*
      call rpolpp (xc,xi,csr,cspr,nt,ip)
      call rpolp (xd,xi,dsr,dspr,nt)
      dr = csr / dsr
      dpr = ( cspr * dsr - csr * dspr ) / ( dsr * dsr )
*     error estimates
      if ( ierr .ne. 0 ) then
	 nt1 = nt - 1
         call rpolpp (xcp,xi,csr,cspr,nt1,ip)
         call rpolp (xdp,xi,dsr,dspr,nt1)
         dr1 = csr / dsr
         dpr1 = ( cspr * dsr - csr * dspr ) / ( dsr * dsr )
	 aerr = abs(dr-dr1)
	 aepr = abs(dpr-dpr1)
      endif
      return
      end
