      SUBROUTINE F02AEF(A,IA,B,IB,N,R,V,IV,DL,E,IFAIL)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 13 REVISED. USE OF MARK 12 X02 FUNCTIONS (APR 1988).
C     MARK 14 REVISED. IER-737 (DEC 1989).
C
C     EIGENVALUES AND EIGENVECTORS OF A-LAMBDA*B
C     1ST DECEMBER 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AEF')
C     .. Scalar Arguments ..
      INTEGER           IA, IB, IFAIL, IV, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), B(IB,N), DL(N), E(N), R(N), V(IV,N)
C     .. Local Scalars ..
      DOUBLE PRECISION  XXXX
      INTEGER           ISAVE
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF
      EXTERNAL          X02AJF, P01ABF
C     .. External Subroutines ..
      EXTERNAL          F01AEF, F01AFF, F01AJF, F02AMF
C     .. Executable Statements ..
      ISAVE = IFAIL
      IFAIL = 1
      CALL F01AEF(N,A,IA,B,IB,DL,IFAIL)
      IF (IFAIL.EQ.0) GO TO 20
      IFAIL = P01ABF(ISAVE,IFAIL,SRNAME,0,P01REC)
      RETURN
   20 CONTINUE
      CALL F01AJF(N,XXXX,A,IA,R,E,V,IV)
      IFAIL = 1
      CALL F02AMF(N,X02AJF(),R,E,V,IV,IFAIL)
      IF (IFAIL.EQ.0) GO TO 40
      IFAIL = P01ABF(ISAVE,2,SRNAME,0,P01REC)
      RETURN
   40 CALL F01AFF(N,1,N,B,IB,DL,V,IV)
      RETURN
      END
      SUBROUTINE F01AEF(N,A,IA,B,IB,DL,IFAIL)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C     MARK 11 REVISED. VECTORISATION (JAN 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 12 REVISED. EXTENDED BLAS (JUNE 1986)
C
C     REDUC1
C     REDUCTION OF THE GENERAL SYMMETRIC EIGENVALUE PROBLEM A * X =
C     LAMBDA * B * X, WITH SYMMETRIC MATRIX A AND SYMMETRIC
C     POSITIVE DEFINITE MATRIX B, TO THE EQUIVALENT STANDARD
C     PROBLEM P * Z = LAMBDA * Z. THE UPPER TRIANGLE, INCLUDING
C     DIAGONAL ELEMENTS, OF A AND B ARE GIVEN IN THE ARRAYS A(N,N)
C     AND B(N,N). L(B = L * LT) IS FORMED IN THE
C     REMAINING STRICTLY LOWER TRIANGLE OF THE ARRAY B WITH ITS
C     DIAGONAL ELEMENTS IN THE ARRAY DL(N) , AND THE LOWER
C     TRIANGLE OF THE SYMMETRIC MATRIX P(P = INV(L) * A * INV( LT))
C     IS FORMED IN THE LOWER TRIANGLE OF THE ARRAY A, INCLUDING THE
C     DIAGONAL ELEMENTS. HENCE THE DIAGONAL ELEMENTS OF A ARE LOST.
C     THE SUBROUTINE WILL FAIL IF B, PERHAPS ON ACCOUNT OF ROUNDING
C     ERRORS, IS NOT POSITIVE DEFINITE - SETS IFAIL = 0 IF
C     SUCCESSFUL ELSE IFAIL = 1.
C     1ST DECEMBER 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F01AEF')
C     .. Scalar Arguments ..
      INTEGER           IA, IB, IFAIL, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), B(IB,N), DL(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  X, Y
      INTEGER           I, IB1, J
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          DGEMV, DSWAP, DTRSV
C     .. Intrinsic Functions ..
      INTRINSIC         SQRT
C     .. Executable Statements ..
C     COPY UPPER TRIANGLES OF A AND B INTO LOWER TRIANGLES
C     AND DIAGONAL OF B INTO DL
      DO 40 J = 1, N
         DO 20 I = 1, J
            A(J,I) = A(I,J)
            B(J,I) = B(I,J)
   20    CONTINUE
         DL(J) = B(J,J)
   40 CONTINUE
      DO 80 I = 1, N
         X = B(I,I)
         IF (X.LE.0.0D0) GO TO 160
         X = SQRT(X)
         B(I,I) = X
         IF (I.GE.N) GO TO 80
         DO 60 J = I + 1, N
            B(J,I) = B(J,I)/X
   60    CONTINUE
         CALL DGEMV('N',N-I,I,-1.0D0,B(I+1,1),IB,B(I+1,1),IB,1.0D0,
     *              B(I+1,I+1),1)
   80 CONTINUE
C     L HAS BEEN FORMED IN ARRAY B
      DO 120 I = 1, N
         Y = B(I,I)
         CALL DGEMV('N',N-I+1,I-1,-1.0D0,A(I,1),IA,B(I,1),IB,1.0D0,A(I,
     *              I),1)
         DO 100 J = I, N
            A(J,I) = A(J,I)/Y
  100    CONTINUE
  120 CONTINUE
C     THE TRANSPOSE OF THE UPPER TRIANGLE OF
C     INV(L) * A HAS BEEN FORMED IN THE LOWER
C     TRIANGLE OF ARRAY A
      IB1 = IB
      DO 140 J = 1, N
         CALL DGEMV('N',N-J+1,J-1,-1.0D0,B(J,1),IB,A(J,1),IA,1.0D0,A(J,
     *              J),1)
         IF (J.EQ.N) IB1 = 1
         CALL DTRSV('L','N','N',N-J+1,B(J,J),IB1,A(J,J),1)
  140 CONTINUE
      CALL DSWAP(N,DL,1,B,IB+1)
      IFAIL = 0
      RETURN
  160 IFAIL = P01ABF(IFAIL,1,SRNAME,0,P01REC)
      DO 180 J = 1, N
         B(J,J) = DL(J)
  180 CONTINUE
      RETURN
      END
      SUBROUTINE F01AFF(N,IM1,IM2,B,IB,DL,Z,IZ)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4.5 REVISED
C     MARK 11 REVISED. VECTORISATION (JAN 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 12 REVISED. EXTENDED BLAS (JUNE 1986)
C
C     REBAKA
C     THIS SUBROUTINE PERFORMS, ON THE MATRIX OF EIGENVECTORS, Z,
C     STORED
C     IN COLUMNS IM1 TO IM2 OF THE ARRAY Z(N,N), A BACKWARD
C     SUBSTITUTION
C     LT* X = Z, OVER- WRITING X ON Z. THE DIAGONAL ELEMENTS OF L
C     MUST BE STORED IN THE ARRAY DL(N), AND THE REMAINING
C     TRIANGLE IN THE STRICTLY LOWER TRIANGLE OF THE ARRAY B(N,N).
C     THE SUBROUTINES F01AEF AND F01BDF LEAVE L IN THIS
C     DESIRED FORM. IF X DENOTES ANY COLUMN OF THE RESULTANT MATRIX
C     X, THEN X SATISFIES XT * B * X = ZT * Z, WHERE B = L * LT.
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IB, IM1, IM2, IZ, N
C     .. Array Arguments ..
      DOUBLE PRECISION  B(IB,N), DL(N), Z(IZ,IM2)
C     .. Local Scalars ..
      INTEGER           J
C     .. External Subroutines ..
      EXTERNAL          DSWAP, DTRSV
C     .. Executable Statements ..
      CALL DSWAP(N,DL,1,B,IB+1)
      DO 20 J = IM1, IM2
         CALL DTRSV('L','T','N',N,B,IB,Z(1,J),1)
   20 CONTINUE
      CALL DSWAP(N,DL,1,B,IB+1)
      RETURN
      END
