      SUBROUTINE F02AGFR(A,IA,N,RR,RI,Z,IZ,PAIRS,INTGER,IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     MARK 14A REVISED. IER-685 (DEC 1989).
C     Adapted from F02AGF (IJT, July 1996) for compressed eigenvector storage.
C
C     EIGENVALUES AND EIGENVECTORS OF REAL UNSYMMETRIC MATRIX
C     1ST AUGUST 1971
C
C	 If PAIRS: 
C     Z CONTAINS THE REAL AND IMAGINARY PARTS OF THE EIGENVECTORS.
C     IF RI(I) .EQ. 0.0, THE I-TH EIGENVALUE IS REAL AND
C     THE I-TH COLUMN OF Z CONTAINS ITS EIGENVECTOR.
C     IF RI(I) .NE. 0.0, THE I-TH EIGENVALUE IS COMPLEX.
C     IF RI(I) .GT. 0.0, THE EIGENVALUE IS THE FIRST OF
C     A COMPLEX PAIR AND THE I-TH AND (I+1)-TH COLUMNS
C                         OF Z CONTAIN ITS EIGENVECTOR.
C     IF RI(I) .LT. 0.0, THE EIGENVALUE IS THE SECOND OF
C          A COMPLEX PAIR AND THE (I-1)-TH AND I-TH COLUMNS
C          OF Z CONTAIN THE CONJUGATE OF ITS EIGENVECTOR.
C     EACH EIGENVECTOR IS NORMALIZED SO THAT THE COMPONENT WITH
C          LARGEST MODULUS IS REAL AND THE SUM OF SQUARES OF THE
C          MODULI OF THE COMPONENTS IS EQUAL TO 1.0
C
C	 If not PAIR, the imaginary parts of the eigenvectors are thrown away.
C		and a duplicate (real) eigenvectors appears
C	 Thus complex eigenvalues, from e.g. numerical inaccuracies,
C 	        appear as repeated eigenvectors with same (complex) eigenvalue.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AGF')
C     .. Scalar Arguments ..
      INTEGER           IA, IFAIL, IZ, N
      LOGICAL		PAIRS
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), RI(N), RR(N), Z(IZ,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  C, D, MACHEP, MAX, SUM, TERM
      INTEGER           I, IB, ISAVE, J, K, L
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF, X02BHF
      EXTERNAL          X02AJF, P01ABF, X02BHF
C     .. External Subroutines ..
      EXTERNAL          F01AKF, F01APF, F01ATF, F01AUF, F02AQF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
      IFAIL = 1
      MACHEP = X02AJF()
      IB = X02BHF()
      CALL F01ATF(N,IB,A,IA,K,L,RR)
      CALL F01AKF(N,K,L,A,IA,INTGER)
      CALL F01APF(N,K,L,INTGER,A,IA,Z,IZ)
      CALL F01AUF(N,K,L,N,RR,Z,IZ)
      CALL F02AQF(N,1,N,MACHEP,A,IA,Z,IZ,RR,RI,INTGER,IFAIL)
      IF (IFAIL.EQ.0) GO TO 20
      IFAIL = P01ABF(ISAVE,IFAIL,SRNAME,0,P01REC)
      RETURN
   20 DO 280 I = 1, N
	if(RI(I).lt.0.0D0) go to 280
c			Just deal with the (first) RI(I)>=0 case
         SUM = 0.0D0
         MAX = 0.0D0
         DO 180 J = 1, N
            IF (ABS(Z(J,I)).LE.MAX) GO TO 160
            MAX = ABS(Z(J,I))
  160       IF (I+1.gt.N)  GO TO 180
            IF (RI(I).eq.0.0d0 .or. ABS(Z(J,I+1)).LE.MAX) GO TO 180
            MAX = ABS(Z(J,I+1))
  180    CONTINUE
         DO 200 J = 1, N
            Z(J,I) = Z(J,I)/MAX
            IF (I+1.gt.N)  GO TO 200
            if(RI(I).ne.0.0d0) Z(J,I+1) = Z(J,I+1)/MAX
  200    CONTINUE
         MAX = 0.0D0
         DO 240 J = 1, N
            TERM = Z(J,I)**2 
            if(RI(I).ne.0.0d0.and.I.lt.N) TERM = TERM + Z(J,I+1)**2
            SUM = SUM + TERM
            IF (TERM.LE.MAX) GO TO 220
            MAX = TERM
            C = Z(J,I)
	    D = 0.d0
            if(RI(I).ne.0.0d0.and.I.lt.N) D = -Z(J,I+1)
  220       CONTINUE
  240    CONTINUE
         SUM = SUM*(C**2+D**2)
         SUM = SQRT(SUM)
         DO 260 J = 1, N
            TERM = Z(J,I)
	   if(RI(I).eq.0.0d0) then
            Z(J,I) = Z(J,I)*C/SUM
	   else
	    if(I.lt.N) then
            Z(J,I)   = (Z(J,I)*C-Z(J,I+1)*D)/SUM
            Z(J,I+1) = (D*TERM+C*Z(J,I+1))/SUM
	    endif
	   endif
  260    CONTINUE
  280 CONTINUE
      if(PAIRS) go to 350
      DO 340 I = 1, N
         if (RI(I).lt.0.0D0) then
C			if not PAIRS, just duplicate real part:
         DO 330 J = 1, N
            Z(J,I) = Z(J,I-1)
  330    CONTINUE
	 endif
  340 CONTINUE
  350 RETURN
      END
      SUBROUTINE F01AKF(N,K,L,A,IA,INTGER)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 8 REVISED. IER-248 (JUN 1980).
C     MARK 11 REVISED. VECTORISATION (JAN 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 12 REVISED. EXTENDED BLAS (JUNE 1986)
C
C     DIRHES
C     AUGUST 1ST, 1971 .
C     GIVEN THE UNSYMMETRIC MATRIX, A, STORED IN THE ARRAY A(N,N),
C     THIS SUBROUTINE REDUCES THE SUB-MATRIX OF ORDER L - K + 1,
C     WHICH STARTS AT THE ELEMENT A(K,K) AND FINISHES AT THE
C     ELEMENT A(L,L), TO HESSENBERG FORM, H, BY THE DIRECT
C     METHOD(AN = NH). THE MATRIX H IS OVERWRITTEN ON A WITH
C     DETAILS OF THE TRANSFORMATIONS (N) STORED IN THE REMAINING
C     TRIANGLE UNDER H AND IN ELEMENTS K TO L OF THE ARRAY
C     INTGER(N).
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IA, K, L, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  X, Y
      INTEGER           I, J, K1, M
C     .. External Subroutines ..
      EXTERNAL          DGEMV, DTRSV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      K1 = K + 1
      IF (K1.GT.L) RETURN
      DO 140 J = K1, N
         M = J
         X = 0.0D0
         IF (J.GT.L) GO TO 120
         DO 20 I = J, L
            IF (ABS(A(I,J-1)).LE.ABS(X)) GO TO 20
            X = A(I,J-1)
            M = I
   20    CONTINUE
         INTGER(J) = M
         IF (M.EQ.J) GO TO 80
C        INTERCHANGE ROWS AND COLUMNS OF A.
         DO 40 I = K, N
            Y = A(M,I)
            A(M,I) = A(J,I)
            A(J,I) = Y
   40    CONTINUE
         DO 60 I = 1, L
            Y = A(I,M)
            A(I,M) = A(I,J)
            A(I,J) = Y
   60    CONTINUE
   80    IF (X.NE.0.0D0 .AND. J.LT.L) THEN
            DO 100 I = J + 1, L
               A(I,J-1) = A(I,J-1)/X
  100       CONTINUE
            CALL DGEMV('N',L,L-J,1.0D0,A(1,J+1),IA,A(J+1,J-1),1,1.0D0,
     *                 A(1,J),1)
         END IF
  120    CALL DTRSV('L','N','U',J-K,A(K+1,K),IA,A(K+1,J),1)
         IF (J.LT.L) CALL DGEMV('N',L-J,J-K,-1.0D0,A(J+1,K),IA,A(K+1,J),
     *                          1,1.0D0,A(J+1,J),1)
  140 CONTINUE
      RETURN
      END
      SUBROUTINE F01APF(N,LOW,IUPP,INTGER,H,IH,V,IV)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     DIRTRANS
C     FORM THE MATRIX OF ACCUMULATED TRANSFORMATIONS IN THE ARRAY
C     V(N,N) FROM THE INFORMATION LEFT BY SUBROUTINE F01AKF
C     BELOW THE UPPER HESSENBERG MATRIX, H, IN THE ARRAY H(N,N)
C     AND IN THE INTEGER ARRAY INTGER(N).
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IH, IUPP, IV, LOW, N
C     .. Array Arguments ..
      DOUBLE PRECISION  H(IH,N), V(IV,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  X
      INTEGER           I, I1, II, J, LOW1, M
C     .. Executable Statements ..
      DO 40 I = 1, N
         DO 20 J = 1, N
            V(I,J) = 0.0D0
   20    CONTINUE
         V(I,I) = 1.0D0
   40 CONTINUE
      LOW1 = LOW + 1
      IF (LOW1.GT.IUPP) RETURN
      DO 120 II = LOW1, IUPP
         I = LOW1 + IUPP - II
         I1 = I - 1
         IF (LOW1.GT.I1) GO TO 80
         DO 60 J = LOW1, I1
            V(I,J) = H(I,J-1)
   60    CONTINUE
   80    M = INTGER(I)
         IF (M.EQ.I) GO TO 120
         DO 100 J = LOW1, IUPP
            X = V(M,J)
            V(M,J) = V(I,J)
            V(I,J) = X
  100    CONTINUE
  120 CONTINUE
      RETURN
      END
      SUBROUTINE F01ATF(N,IB,A,IA,LOW,LHI,D)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     BALANCE
C     REDUCE THE NORM OF A(N,N) BY EXACT DIAGONAL SIMILARITY
C     TRANSFORMATIONS STORED IN D(N).
C     DECEMBER 1ST.,1971
C
C     .. Scalar Arguments ..
      INTEGER           IA, IB, LHI, LOW, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  B2, C, F, G, R, S
      INTEGER           I, J, JJ, K, L
      LOGICAL           NOCONV
C     .. External Subroutines ..
      EXTERNAL          F01ATZ
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, DBLE
C     .. Executable Statements ..
      B2 = IB*IB
      L = 1
      K = N
   20 IF (K.LT.1) GO TO 100
C     SEARCH FOR ROWS ISOLATING AN EIGENVALUE AND PUSH THEM DOWN
      J = K + 1
      DO 60 JJ = 1, K
         J = J - 1
         R = 0.0D0
         DO 40 I = 1, K
            IF (I.EQ.J) GO TO 40
            R = R + ABS(A(J,I))
   40    CONTINUE
         IF (R.EQ.0.0D0) GO TO 80
   60 CONTINUE
      GO TO 100
   80 CALL F01ATZ(K,A,IA,D,K,L,N,J)
      K = K - 1
      GO TO 20
C     SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE AND PUSH THEM
C     LEFT.
  100 IF (L.GT.K) GO TO 180
      DO 140 J = L, K
         C = 0.0D0
         DO 120 I = L, K
            IF (I.EQ.J) GO TO 120
            C = C + ABS(A(I,J))
  120    CONTINUE
         IF (C.EQ.0.0D0) GO TO 160
  140 CONTINUE
      GO TO 180
  160 CALL F01ATZ(L,A,IA,D,K,L,N,J)
      L = L + 1
      GO TO 100
C     NOW BALANCE THE SUBMATRIX IN ROWS L THROUGH K.
  180 LOW = L
      LHI = K
      IF (L.GT.K) GO TO 220
      DO 200 I = L, K
         D(I) = 1.0D0
  200 CONTINUE
  220 NOCONV = .FALSE.
      IF (L.GT.K) GO TO 420
      DO 400 I = L, K
         C = 0.0D0
         R = 0.0D0
         DO 240 J = L, K
            IF (J.EQ.I) GO TO 240
            C = C + ABS(A(J,I))
            R = R + ABS(A(I,J))
  240    CONTINUE
         G = R/DBLE(IB)
         F = 1.0D0
         S = C + R
  260    IF (C.GE.G) GO TO 280
         F = F*DBLE(IB)
         C = C*B2
         GO TO 260
  280    G = R*DBLE(IB)
  300    IF (C.LT.G) GO TO 320
         F = F/DBLE(IB)
         C = C/B2
         GO TO 300
  320    IF (((C+R)/F).GE.(0.95D0*S)) GO TO 400
         G = 1.0D0/F
         D(I) = D(I)*F
         NOCONV = .TRUE.
         IF (L.GT.N) GO TO 360
         DO 340 J = L, N
            A(I,J) = A(I,J)*G
  340    CONTINUE
  360    DO 380 J = 1, K
            A(J,I) = A(J,I)*F
  380    CONTINUE
  400 CONTINUE
  420 IF (NOCONV) GO TO 220
      RETURN
      END
      SUBROUTINE F01AUF(N,LOW,LHI,M,D,Z,IZ)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     BALBAK
C     BACKWARD TRANSFORMATION OF A SET OF RIGHT-HAND EIGENVECTORS
C     OF A BALANCED MATRIX INTO THE EIGENVECTORS OF THE ORIGINAL
C     MATRIX FROM WHICH THE BALANCED MATRIX WAS DERIVED BY A CALL
C     OF SUBROUTINE F01ATF.
C     DECEMBER 1ST.,1971
C
C     .. Scalar Arguments ..
      INTEGER           IZ, LHI, LOW, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  D(N), Z(IZ,M)
C     .. Local Scalars ..
      DOUBLE PRECISION  S
      INTEGER           I, II, J, K, LHI1, LOW1
C     .. Executable Statements ..
      IF (LOW.GT.LHI) GO TO 60
      DO 40 I = LOW, LHI
         S = D(I)
C        LEFT-HAND EIGENVECTORS ARE BACK TRANSFORMED IF THE
C        FOREGOING STATEMENT IS REPLACED BY S=1/D(I)
         DO 20 J = 1, M
            Z(I,J) = Z(I,J)*S
   20    CONTINUE
   40 CONTINUE
   60 I = LOW
      LOW1 = LOW - 1
      IF (LOW1.LT.1) GO TO 120
      DO 100 II = 1, LOW1
         I = I - 1
         K = D(I)
         IF (K.EQ.I) GO TO 100
         DO 80 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
   80    CONTINUE
  100 CONTINUE
  120 LHI1 = LHI + 1
      IF (LHI1.GT.N) RETURN
      DO 160 I = LHI1, N
         K = D(I)
         IF (K.EQ.I) GO TO 160
         DO 140 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
  140    CONTINUE
  160 CONTINUE
      RETURN
      END
      SUBROUTINE F02AQF(N,LOW,UPP,MACHEP,H,IH,VECS,IVECS,WR,WI,CNT,
     *                  IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C
C     HQR2
C     FINDS THE EIGENVALUES AND EIGENVECTORS OF A REAL MATRIX
C     WHICH HAS BEEN REDUCED TO UPPER HESSENBERG FORM IN THE ARRAY
C     H(N,N) WITH THE ACCUMULATED TRANSFORMATIONS STORED IN
C     THE ARRAY VECS(N,N). THE REAL AND IMAGINARY PARTS OF THE
C     EIGENVALUES ARE FORMED IN THE ARRAYS WR, WI(N) AND THE
C     EIGENVECTORS ARE FORMED IN THE ARRAY VECS(N,N) WHERE
C     ONLY ONE COMPLEX VECTOR, CORRESPONDING TO THE ROOT WITH
C     POSITIVE IMAGINARY PART, IS FORMED FOR A COMPLEX PAIR. LOW
C     AND UPP ARE TWO INTEGERS PRODUCED IN BALANCING WHERE
C     EIGENVALUES ARE ISOLATED IN POSITIONS 1 TO LOW-1 AND UPP+1
C     TO N. IF BALANCING IS NOT USED LOW=1, UPP=N. MACHEP IS THE
C     RELATIVE MACHINE PRECISION. THE SUBROUTINE WILL FAIL IF
C     ALL EIGENVALUES TAKE MORE THAN 30*N ITERATIONS.
C     1ST DECEMBER 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AQF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  MACHEP
      INTEGER           IFAIL, IH, IVECS, LOW, N, UPP
C     .. Array Arguments ..
      DOUBLE PRECISION  H(IH,N), VECS(IVECS,N), WI(N), WR(N)
      INTEGER           CNT(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  NORM, P, Q, R, RA, S, SA, T, U, VI, VR, W, X, Y,
     *                  Z
      INTEGER           EN, EN2, I, I1, II, ISAVE, ITN, ITS, J, JJ, K,
     *                  KK, L, LL, LOW1, M, M2, M3, MM, NA, NA1, NHS,
     *                  UPP1
      LOGICAL           NOTLAS
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  A02ABF, X02AJF, X02AKF
      INTEGER           P01ABF
      EXTERNAL          A02ABF, X02AJF, X02AKF, P01ABF
C     .. External Subroutines ..
      EXTERNAL          A02ACF, DGEMV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MIN, DBLE, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
C     COMPUTE MATRIX NORM
      NORM = 0.0D0
      K = 1
      DO 40 I = 1, N
         DO 20 J = K, N
            NORM = NORM + ABS(H(I,J))
   20    CONTINUE
         K = I
   40 CONTINUE
      NHS = N*(N+1)/2 + N - 1
C     ISOLATED ROOTS
      IF (LOW.LE.1) GO TO 80
      J = LOW - 1
      DO 60 I = 1, J
         WR(I) = H(I,I)
         WI(I) = 0.0D0
         CNT(I) = 0
   60 CONTINUE
   80 IF (UPP.GE.N) GO TO 120
      J = UPP + 1
      DO 100 I = J, N
         WR(I) = H(I,I)
         WI(I) = 0.0D0
         CNT(I) = 0
  100 CONTINUE
  120 EN = UPP
      T = 0.0D0
      ITN = 30*N
  140 IF (EN.LT.LOW) GO TO 880
      ITS = 0
      NA = EN - 1
C     LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT
  160 IF (LOW+1.GT.EN) GO TO 200
      LOW1 = LOW + 1
      DO 180 LL = LOW1, EN
         L = EN + LOW1 - LL
         S = ABS(H(L-1,L-1)) + ABS(H(L,L))
         IF (S.LT.X02AKF()/X02AJF()) S = NORM/DBLE(NHS)
         IF (ABS(H(L,L-1)).LE.MACHEP*S) GO TO 220
  180 CONTINUE
  200 L = LOW
  220 X = H(EN,EN)
      IF (L.EQ.EN) GO TO 740
      Y = H(NA,NA)
      W = H(EN,NA)*H(NA,EN)
      IF (L.EQ.NA) GO TO 760
      IF (ITN.LE.0) GO TO 1500
C     FORM SHIFT
      IF ((ITS.NE.10) .AND. (ITS.NE.20)) GO TO 280
      T = T + X
      IF (LOW.GT.EN) GO TO 260
      DO 240 I = LOW, EN
         H(I,I) = H(I,I) - X
  240 CONTINUE
  260 S = ABS(H(EN,NA)) + ABS(H(NA,EN-2))
      X = 0.75D0*S
      Y = X
      W = -0.4375D0*S**2
  280 ITS = ITS + 1
      ITN = ITN - 1
C     LOOK FOR TWO CONSECUTIVE SMALL SUB-DIAGONAL ELEMENTS
      IF (L.GT.EN-2) GO TO 320
      EN2 = EN - 2
      DO 300 MM = L, EN2
         M = L + EN2 - MM
         Z = H(M,M)
         R = X - Z
         S = Y - Z
         P = (R*S-W)/H(M+1,M) + H(M,M+1)
         Q = H(M+1,M+1) - Z - R - S
         R = H(M+2,M+1)
         S = ABS(P) + ABS(Q) + ABS(R)
         P = P/S
         Q = Q/S
         R = R/S
         IF (M.EQ.L) GO TO 320
         IF ((ABS(H(M,M-1))*(ABS(Q)+ABS(R))).LE.(MACHEP*ABS(P)
     *       *(ABS(H(M-1,M-1))+ABS(Z)+ABS(H(M+1,M+1))))) GO TO 320
  300 CONTINUE
  320 M2 = M + 2
      IF (M2.GT.EN) GO TO 360
      DO 340 I = M2, EN
         H(I,I-2) = 0.0D0
  340 CONTINUE
  360 M3 = M + 3
      IF (M3.GT.EN) GO TO 400
      DO 380 I = M3, EN
         H(I,I-3) = 0.0D0
  380 CONTINUE
  400 IF (M.GT.NA) GO TO 720
      DO 700 K = M, NA
         NOTLAS = K .NE. NA
         IF (K.EQ.M) GO TO 420
         P = H(K,K-1)
         Q = H(K+1,K-1)
         R = 0
         IF (NOTLAS) R = H(K+2,K-1)
         X = ABS(P) + ABS(Q) + ABS(R)
         IF (X.EQ.0.0D0) GO TO 700
         P = P/X
         Q = Q/X
         R = R/X
  420    S = SQRT(P**2+Q**2+R**2)
         IF (P.LT.0.0D0) S = -S
         IF (K.NE.M) GO TO 440
         IF (L.NE.M) H(K,K-1) = -H(K,K-1)
         GO TO 460
  440    H(K,K-1) = -S*X
  460    P = P + S
         X = P/S
         Y = Q/S
         Z = R/S
         Q = Q/P
         R = R/P
C        ROW MODIFICATION
         IF (NOTLAS) GO TO 500
         DO 480 J = K, N
            P = H(K,J) + Q*H(K+1,J)
            H(K+1,J) = H(K+1,J) - P*Y
            H(K,J) = H(K,J) - P*X
  480    CONTINUE
         GO TO 540
  500    DO 520 J = K, N
            P = H(K,J) + Q*H(K+1,J) + R*H(K+2,J)
            H(K+2,J) = H(K+2,J) - P*Z
            H(K+1,J) = H(K+1,J) - P*Y
            H(K,J) = H(K,J) - P*X
  520    CONTINUE
  540    J = EN
         IF (K+3.LT.EN) J = K + 3
C        COLUMN MODIFICATION
         IF (NOTLAS) GO TO 580
         DO 560 I = 1, J
            P = X*H(I,K) + Y*H(I,K+1)
            H(I,K+1) = H(I,K+1) - P*Q
            H(I,K) = H(I,K) - P
  560    CONTINUE
         GO TO 620
  580    DO 600 I = 1, J
            P = X*H(I,K) + Y*H(I,K+1) + Z*H(I,K+2)
            H(I,K+2) = H(I,K+2) - P*R
            H(I,K+1) = H(I,K+1) - P*Q
            H(I,K) = H(I,K) - P
  600    CONTINUE
C        ACCUMULATE TRANSFORMATIONS
  620    IF (LOW.GT.UPP) GO TO 700
         IF (NOTLAS) GO TO 660
         DO 640 I = LOW, UPP
            P = X*VECS(I,K) + Y*VECS(I,K+1)
            VECS(I,K+1) = VECS(I,K+1) - P*Q
            VECS(I,K) = VECS(I,K) - P
  640    CONTINUE
         GO TO 700
  660    DO 680 I = LOW, UPP
            P = X*VECS(I,K) + Y*VECS(I,K+1) + Z*VECS(I,K+2)
            VECS(I,K+2) = VECS(I,K+2) - P*R
            VECS(I,K+1) = VECS(I,K+1) - P*Q
            VECS(I,K) = VECS(I,K) - P
  680    CONTINUE
  700 CONTINUE
  720 GO TO 160
C     ONE ROOT FOUND
  740 WR(EN) = X + T
      H(EN,EN) = WR(EN)
      WI(EN) = 0.0D0
      CNT(EN) = ITS
      EN = NA
      GO TO 140
C     TWO ROOTS FOUND
  760 P = (Y-X)/2.0D0
      Q = P**2 + W
      Z = SQRT(ABS(Q))
      X = X + T
      H(EN,EN) = X
      H(NA,NA) = Y + T
      CNT(EN) = -ITS
      CNT(NA) = ITS
      IF (Q.LT.0.0D0) GO TO 840
C     REAL PAIR
      IF (P.LT.0.0D0) Z = P - Z
      IF (P.GT.0.0D0) Z = P + Z
      WR(NA) = X + Z
      WR(EN) = WR(NA)
      IF (Z.NE.0.0D0) WR(EN) = X - W/Z
      WI(NA) = 0.0D0
      WI(EN) = 0.0D0
      X = H(EN,NA)
      R = A02ABF(X,Z)
      P = X/R
      Q = Z/R
C     ROW MODIFICATION
      DO 780 J = NA, N
         Z = H(NA,J)
         H(NA,J) = Q*Z + P*H(EN,J)
         H(EN,J) = Q*H(EN,J) - P*Z
  780 CONTINUE
C     COLUMN MODIFICATION
      DO 800 I = 1, EN
         Z = H(I,NA)
         H(I,NA) = Q*Z + P*H(I,EN)
         H(I,EN) = Q*H(I,EN) - P*Z
  800 CONTINUE
C     ACCUMULATE TRANSFORMATIONS
      DO 820 I = LOW, UPP
         Z = VECS(I,NA)
         VECS(I,NA) = Q*Z + P*VECS(I,EN)
         VECS(I,EN) = Q*VECS(I,EN) - P*Z
  820 CONTINUE
      GO TO 860
C     COMPLEX PAIR
  840 WR(NA) = X + P
      WR(EN) = X + P
      WI(NA) = Z
      WI(EN) = -Z
  860 EN = EN - 2
      GO TO 140
C     ALL ROOTS FOUND NOW BACKSUBSTITUTE
  880 IF (NORM.EQ.0.0D0) GO TO 1480
      NORM = NORM*MACHEP
C     BACKSUBSTITUTION
      DO 1340 KK = 1, N
         EN = N + 1 - KK
         P = WR(EN)
         Q = WI(EN)
         NA = EN - 1
         IF (Q.NE.0.0D0) GO TO 1120
C        REAL VECTOR
         H(EN,EN) = 1.0D0
         IF (NA.LT.1) GO TO 1340
         DO 1100 II = 1, NA
            I = NA + 1 - II
            I1 = I - 1
            W = H(I,I) - P
            R = H(I,EN)
            IF (WI(I).GE.0.0D0) GO TO 900
            Z = W
            S = R
            GO TO 1100
  900       IF (WI(I).GT.0.0D0) GO TO 1020
C           MODIFICATION TO STOP OVERFLOW
            IF (W.NE.0.0D0) GO TO 940
            IF (ABS(R).LT.10.0D0*NORM) GO TO 960
            R = -R
            DO 920 J = 1, EN
               H(J,EN) = H(J,EN)*NORM
  920       CONTINUE
            GO TO 980
  940       R = -R/W
            GO TO 980
  960       R = -R/NORM
  980       H(I,EN) = R
            IF (I1.EQ.0) GO TO 1100
            DO 1000 J = 1, I1
               H(J,EN) = H(J,EN) + H(J,I)*R
 1000       CONTINUE
            GO TO 1100
C           SOLVE REAL EQUATIONS
 1020       X = H(I,I+1)
            Y = H(I+1,I)
            Q = (WR(I)-P)**2 + WI(I)**2
            T = (X*S-Z*R)/Q
            H(I,EN) = T
            IF (ABS(X).GT.ABS(Z)) GO TO 1040
            R = (-S-Y*T)/Z
            GO TO 1060
 1040       R = (-R-W*T)/X
 1060       H(I+1,EN) = R
            IF (I1.EQ.0) GO TO 1100
            DO 1080 J = 1, I1
               H(J,EN) = (H(J,EN)+H(J,I+1)*R) + H(J,I)*T
 1080       CONTINUE
 1100    CONTINUE
C        END REAL VECTOR
         GO TO 1340
 1120    IF (Q.GT.0.0D0) GO TO 1340
C        COMPLEX VECTOR ASSOCIATED WITH LAMBDA=P-I*Q
         IF (ABS(H(EN,NA)).LE.ABS(H(NA,EN))) GO TO 1140
         R = Q/H(EN,NA)
         S = -(H(EN,EN)-P)/H(EN,NA)
         GO TO 1160
 1140    CALL A02ACF(0.0D0,-H(NA,EN),H(NA,NA)-P,Q,R,S)
 1160    H(EN,NA) = 0.0D0
         H(EN,EN) = 1.0D0
         H(NA,NA) = R
         H(NA,EN) = S
         IF (NA.LT.2) GO TO 1340
         NA1 = NA - 1
         DO 1180 J = 1, NA1
            H(J,EN) = H(J,EN) + H(J,NA)*S
            H(J,NA) = H(J,NA)*R
 1180    CONTINUE
         DO 1320 II = 1, NA1
            I = 1 + NA1 - II
            I1 = I - 1
            W = H(I,I) - P
            RA = H(I,NA)
            SA = H(I,EN)
            IF (WI(I).GE.0.0D0) GO TO 1200
            Z = W
            R = RA
            S = SA
            GO TO 1320
 1200       IF (WI(I).EQ.0.0D0) GO TO 1280
C           SOLVE COMPLEX EQUATIONS
            X = H(I,I+1)
            Y = H(I+1,I)
            VR = (WR(I)-P)**2 + WI(I)**2 - Q**2
            VI = (WR(I)-P)*2.0D0*Q
            IF ((VR.EQ.0.0D0) .AND. (VI.EQ.0.0D0))
     *          VR = MACHEP*NORM*(ABS(W)+ABS(Q)+ABS(X)+ABS(Y)+ABS(Z))
            CALL A02ACF(X*R-Z*RA+Q*SA,X*S-Z*SA-Q*RA,VR,VI,T,U)
            IF (ABS(X).LE.ABS(Z)+ABS(Q)) GO TO 1220
            R = (-RA-W*T+Q*U)/X
            S = (-SA-W*U-Q*T)/X
            GO TO 1240
 1220       CALL A02ACF(-R-Y*T,-S-Y*U,Z,Q,R,S)
 1240       H(I,NA) = T
            H(I,EN) = U
            H(I+1,NA) = R
            H(I+1,EN) = S
            IF (I1.EQ.0) GO TO 1320
            DO 1260 J = 1, I1
               H(J,NA) = (H(J,NA)+H(J,I+1)*R) + H(J,I)*T
               H(J,EN) = (H(J,EN)+H(J,I+1)*S) + H(J,I)*U
 1260       CONTINUE
            GO TO 1320
 1280       CALL A02ACF(-RA,-SA,W,Q,R,S)
            H(I,NA) = R
            H(I,EN) = S
            IF (I1.EQ.0) GO TO 1320
            DO 1300 J = 1, I1
               H(J,NA) = H(J,NA) + H(J,I)*R
               H(J,EN) = H(J,EN) + H(J,I)*S
 1300       CONTINUE
 1320    CONTINUE
C        END COMPLEX VECTOR
 1340 CONTINUE
C     END BACKSUBSTITUTION
C     VECTORS OF ISOLATED ROOTS
      LOW1 = LOW - 1
      UPP1 = UPP + 1
      DO 1420 J = 1, N
         M = MIN(J,LOW1)
         IF (M.LT.1) GO TO 1380
         DO 1360 I = 1, M
            VECS(I,J) = H(I,J)
 1360    CONTINUE
 1380    IF (UPP1.GT.J) GO TO 1420
         DO 1400 I = UPP1, J
            VECS(I,J) = H(I,J)
 1400    CONTINUE
 1420 CONTINUE
C     MULTIPLY BY TRANSFORMATION MATRIX TO GIVE
C     VECTORS OF ORIGINAL FULL MATRIX
      DO 1460 JJ = LOW, N
         J = LOW + N - JJ
         M = MIN(J,UPP)
         DO 1440 I = LOW, UPP
            VECS(I,J) = VECS(I,M)*H(M,J)
 1440    CONTINUE
         M = M - 1
         IF (M+1.GE.LOW) CALL DGEMV('N',UPP-LOW+1,M-LOW+1,1.0D0,
     *                              VECS(LOW,LOW),IVECS,H(LOW,J),1,
     *                              1.0D0,VECS(LOW,J),1)
 1460 CONTINUE
 1480 IFAIL = 0
      RETURN
 1500 IFAIL = P01ABF(ISAVE,1,SRNAME,0,P01REC)
      RETURN
      END
      SUBROUTINE F01ATZ(M,A,IA,D,K,L,N,J)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C
C     AUXILIARY ROUTINE CALLED BY F01ATF.
C     INTERCHANGES ELEMENTS 1 TO K OF COLUMNS J AND M,
C     AND ELEMENTS L TO N OF ROWS J AND M.
C     .. Scalar Arguments ..
      INTEGER           IA, J, K, L, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  F
      INTEGER           I
C     .. Executable Statements ..
      D(M) = J
      IF (J.EQ.M) GO TO 60
      DO 20 I = 1, K
         F = A(I,J)
         A(I,J) = A(I,M)
         A(I,M) = F
   20 CONTINUE
      IF (L.GT.N) GO TO 60
      DO 40 I = L, N
         F = A(J,I)
         A(J,I) = A(M,I)
         A(M,I) = F
   40 CONTINUE
   60 RETURN
      END
      DOUBLE PRECISION FUNCTION A02ABF(XXR,XXI)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     RETURNS THE ABSOLUTE VALUE OF A COMPLEX NUMBER VIA ROUTINE
C     NAME
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION                 XXI, XXR
C     .. Local Scalars ..
      DOUBLE PRECISION                 H, ONE, XI, XR, ZERO
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, SQRT
C     .. Data statements ..
      DATA                             ZERO/0.0D0/, ONE/1.0D0/
C     .. Executable Statements ..
C
      XR = ABS(XXR)
      XI = ABS(XXI)
      IF (XI.LE.XR) GO TO 20
      H = XR
      XR = XI
      XI = H
   20 IF (XI.NE.ZERO) GO TO 40
      A02ABF = XR
      RETURN
   40 H = XR*SQRT(ONE+(XI/XR)**2)
      A02ABF = H
      RETURN
      END
      SUBROUTINE A02ACF(XXR,XXI,YYR,YYI,ZR,ZI)
C     MARK 2A RELEASE.  NAG COPYRIGHT 1973
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     DIVIDES ONE COMPLEX NUMBER BY A SECOND
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION  XXI, XXR, YYI, YYR, ZI, ZR
C     .. Local Scalars ..
      DOUBLE PRECISION  A, H, ONE
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Data statements ..
      DATA              ONE/1.0D0/
C     .. Executable Statements ..
C
      IF (ABS(YYR).LE.ABS(YYI)) GO TO 20
      H = YYI/YYR
      A = ONE/(H*YYI+YYR)
      ZR = (XXR+H*XXI)*A
      ZI = (XXI-H*XXR)*A
      RETURN
   20 H = YYR/YYI
      A = ONE/(H*YYR+YYI)
      ZR = (H*XXR+XXI)*A
      ZI = (H*XXI-XXR)*A
      RETURN
      END
      INTEGER FUNCTION X02BHF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS THE MODEL PARAMETER, B.
C
C     .. Executable Statements ..
      X02BHF =     2
      RETURN
      END
      DOUBLE PRECISION FUNCTION X02AKF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  B**(EMIN-1)  (THE SMALLEST POSITIVE MODEL NUMBER)
C
      DOUBLE PRECISION X02CON
!      DATA X02CON /Z'0010000000000000' /
C     .. Executable Statements ..
      X02AKF = tiny(X02CON)
      RETURN
      END
      SUBROUTINE M01AJF(A,W,IND,INDW,N,NW,IFAIL)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     SORTS A VECTOR OF REAL NUMBERS INTO ASCENDING ORDER AND
C     PROVIDES AN IN
C     INDICATING THE POSITION OF THE SORTED NUMBERS IN THE ORIGINAL
C     ARRAY.
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='M01AJF')
C     .. Scalar Arguments ..
      INTEGER           IFAIL, N, NW
C     .. Array Arguments ..
      DOUBLE PRECISION  A(N), W(NW)
      INTEGER           IND(N), INDW(NW)
C     .. Local Scalars ..
      INTEGER           I, IKO, IL1, IL2, IW, IW1, J, J1, K, L1, L2, L3,
     *                  N21, NDO, NM, NN
C     .. Local Arrays ..
      INTEGER           IST(20), KOUNT(20)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC         MIN
C     .. Executable Statements ..
      K = 0
      IF (N-1) 20, 680, 40
   20 K = 1
   40 IF (NW) 640, 640, 60
   60 IF (K) 660, 80, 660
   80 NN = MIN(N,NW)
      DO 100 K = 1, N
         IND(K) = K
  100 CONTINUE
      L3 = 1
      IKO = 0
  120 IKO = IKO + 1
  140 NM = 1
      L1 = L3
  160 L2 = MIN(L1+NM,N+1)
      L3 = MIN(L2+NM,N+1)
      KOUNT(IKO) = L3 - L1
      IST(IKO) = L1
  180 IW = 1
      IL1 = L1
      IL2 = L2
  200 NDO = MIN(IL2-L1,L3-L2,NN-IW+1)
      IF (NDO) 320, 320, 220
  220 DO 300 I = 1, NDO
         IF (A(L1)-A(L2)) 240, 240, 260
  240    W(IW) = A(L1)
         INDW(IW) = IND(L1)
         L1 = L1 + 1
         GO TO 280
  260    W(IW) = A(L2)
         INDW(IW) = IND(L2)
         L2 = L2 + 1
  280    IW = IW + 1
  300 CONTINUE
      GO TO 200
  320 IF (IL2-L1) 340, 340, 460
  340 IW1 = IW - 1
  360 DO 380 I = 1, IW1
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  380 CONTINUE
  400 IF (IKO-1) 420, 420, 580
  420 IF (L3-N) 440, 440, 700
  440 IKO = 2
      GO TO 140
  460 IF (L3-L2) 480, 480, 520
  480 J = L3 - 1
      K = IL2 - L1
      J1 = IL2 - 1
      DO 500 I = 1, K
         A(J) = A(J1)
         IND(J) = IND(J1)
         J = J - 1
         J1 = J1 - 1
  500 CONTINUE
      IW1 = IW - 1
      IF (IW1) 400, 400, 360
  520 J = IL2 - 1
      K = L2 - 1
      N21 = IL2 - L1
      DO 540 I = 1, N21
         A(K) = A(J)
         IND(K) = IND(J)
         K = K - 1
         J = J - 1
  540 CONTINUE
      DO 560 I = 1, NN
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  560 CONTINUE
      L1 = K + 1
      GO TO 180
  580 IF (L3-N) 600, 600, 620
  600 IF (KOUNT(IKO-1)-NM-NM) 620, 620, 120
  620 IKO = IKO - 1
      NM = KOUNT(IKO)
      L1 = IST(IKO)
      GO TO 160
  640 K = K + 2
  660 IFAIL = P01ABF(IFAIL,K,SRNAME,0,P01REC)
      RETURN
  680 IND(1) = 1
  700 IFAIL = 0
      RETURN
      END
