      SUBROUTINE F02AGFR(A,IA,N,RR,RI,Z,IZ,PAIRS,INTGER,IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     MARK 14A REVISED. IER-685 (DEC 1989).
C     Adapted from F02AGF (IJT, July 1996) for compressed eigenvector storage.
C
C     EIGENVALUES AND EIGENVECTORS OF REAL UNSYMMETRIC MATRIX
C     1ST AUGUST 1971
C
C	 If PAIRS: 
C     Z CONTAINS THE REAL AND IMAGINARY PARTS OF THE EIGENVECTORS.
C     IF RI(I) .EQ. 0.0, THE I-TH EIGENVALUE IS REAL AND
C     THE I-TH COLUMN OF Z CONTAINS ITS EIGENVECTOR.
C     IF RI(I) .NE. 0.0, THE I-TH EIGENVALUE IS COMPLEX.
C     IF RI(I) .GT. 0.0, THE EIGENVALUE IS THE FIRST OF
C     A COMPLEX PAIR AND THE I-TH AND (I+1)-TH COLUMNS
C                         OF Z CONTAIN ITS EIGENVECTOR.
C     IF RI(I) .LT. 0.0, THE EIGENVALUE IS THE SECOND OF
C          A COMPLEX PAIR AND THE (I-1)-TH AND I-TH COLUMNS
C          OF Z CONTAIN THE CONJUGATE OF ITS EIGENVECTOR.
C     EACH EIGENVECTOR IS NORMALIZED SO THAT THE COMPONENT WITH
C          LARGEST MODULUS IS REAL AND THE SUM OF SQUARES OF THE
C          MODULI OF THE COMPONENTS IS EQUAL TO 1.0
C
C	 If not PAIR, the imaginary parts of the eigenvectors are thrown away.
C		and a duplicate (real) eigenvectors appears
C	 Thus complex eigenvalues, from e.g. numerical inaccuracies,
C 	        appear as repeated eigenvectors with same (complex) eigenvalue.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AGF')
C     .. Scalar Arguments ..
      INTEGER           IA, IFAIL, IZ, N
      LOGICAL		PAIRS
C     .. Array Arguments ..
      DOUBLE PRECISION  A(IA,N), RI(N), RR(N), Z(IZ,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  C, D, MACHEP, MAX, SUM, TERM
      INTEGER           I, IB, ISAVE, J, K, L
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF, X02BHF
      EXTERNAL          X02AJF, P01ABF, X02BHF
C     .. External Subroutines ..
      EXTERNAL          F01AKF, F01APF, F01ATF, F01AUF, F02AQF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
      IFAIL = 1
      MACHEP = X02AJF()
      IB = X02BHF()
      CALL F01ATF(N,IB,A,IA,K,L,RR)
      CALL F01AKF(N,K,L,A,IA,INTGER)
      CALL F01APF(N,K,L,INTGER,A,IA,Z,IZ)
      CALL F01AUF(N,K,L,N,RR,Z,IZ)
      CALL F02AQF(N,1,N,MACHEP,A,IA,Z,IZ,RR,RI,INTGER,IFAIL)
      IF (IFAIL.EQ.0) GO TO 20
      IFAIL = P01ABF(ISAVE,IFAIL,SRNAME,0,P01REC)
      RETURN
   20 DO 280 I = 1, N
	if(RI(I).lt.0.0D0) go to 280
c			Just deal with the (first) RI(I)>=0 case
         SUM = 0.0D0
         MAX = 0.0D0
         DO 180 J = 1, N
            IF (ABS(Z(J,I)).LE.MAX) GO TO 160
            MAX = ABS(Z(J,I))
  160       IF (RI(I).eq.0.0d0 .or. ABS(Z(J,I+1)).LE.MAX) GO TO 180
            MAX = ABS(Z(J,I+1))
  180    CONTINUE
         DO 200 J = 1, N
            Z(J,I) = Z(J,I)/MAX
            if(RI(I).ne.0.0d0) Z(J,I+1) = Z(J,I+1)/MAX
  200    CONTINUE
         MAX = 0.0D0
         DO 240 J = 1, N
            TERM = Z(J,I)**2 
            if(RI(I).ne.0.0d0) TERM = TERM + Z(J,I+1)**2
            SUM = SUM + TERM
            IF (TERM.LE.MAX) GO TO 220
            MAX = TERM
            C = Z(J,I)
	    D = 0.d0
            if(RI(I).ne.0.0d0) D = -Z(J,I+1)
  220       CONTINUE
  240    CONTINUE
         SUM = SUM*(C**2+D**2)
         SUM = SQRT(SUM)
         DO 260 J = 1, N
            TERM = Z(J,I)
	   if(RI(I).eq.0.0d0) then
            Z(J,I) = Z(J,I)*C/SUM
	   else
            Z(J,I)   = (Z(J,I)*C-Z(J,I+1)*D)/SUM
            Z(J,I+1) = (D*TERM+C*Z(J,I+1))/SUM
	   endif
  260    CONTINUE
  280 CONTINUE
      if(PAIRS) go to 350
      DO 340 I = 1, N
         if (RI(I).lt.0.0D0) then
C			if not PAIRS, just duplicate real part:
         DO 330 J = 1, N
            Z(J,I) = Z(J,I-1)
  330    CONTINUE
	 endif
  340 CONTINUE
  350 RETURN
      END
      SUBROUTINE M01AJF(A,W,IND,INDW,N,NW,IFAIL)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     SORTS A VECTOR OF REAL NUMBERS INTO ASCENDING ORDER AND
C     PROVIDES AN IN
C     INDICATING THE POSITION OF THE SORTED NUMBERS IN THE ORIGINAL
C     ARRAY.
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='M01AJF')
C     .. Scalar Arguments ..
      INTEGER           IFAIL, N, NW
C     .. Array Arguments ..
      DOUBLE PRECISION  A(N), W(NW)
      INTEGER           IND(N), INDW(NW)
C     .. Local Scalars ..
      INTEGER           I, IKO, IL1, IL2, IW, IW1, J, J1, K, L1, L2, L3,
     *                  N21, NDO, NM, NN
C     .. Local Arrays ..
      INTEGER           IST(20), KOUNT(20)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC         MIN
C     .. Executable Statements ..
      K = 0
      IF (N-1) 20, 680, 40
   20 K = 1
   40 IF (NW) 640, 640, 60
   60 IF (K) 660, 80, 660
   80 NN = MIN(N,NW)
      DO 100 K = 1, N
         IND(K) = K
  100 CONTINUE
      L3 = 1
      IKO = 0
  120 IKO = IKO + 1
  140 NM = 1
      L1 = L3
  160 L2 = MIN(L1+NM,N+1)
      L3 = MIN(L2+NM,N+1)
      KOUNT(IKO) = L3 - L1
      IST(IKO) = L1
  180 IW = 1
      IL1 = L1
      IL2 = L2
  200 NDO = MIN(IL2-L1,L3-L2,NN-IW+1)
      IF (NDO) 320, 320, 220
  220 DO 300 I = 1, NDO
         IF (A(L1)-A(L2)) 240, 240, 260
  240    W(IW) = A(L1)
         INDW(IW) = IND(L1)
         L1 = L1 + 1
         GO TO 280
  260    W(IW) = A(L2)
         INDW(IW) = IND(L2)
         L2 = L2 + 1
  280    IW = IW + 1
  300 CONTINUE
      GO TO 200
  320 IF (IL2-L1) 340, 340, 460
  340 IW1 = IW - 1
  360 DO 380 I = 1, IW1
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  380 CONTINUE
  400 IF (IKO-1) 420, 420, 580
  420 IF (L3-N) 440, 440, 700
  440 IKO = 2
      GO TO 140
  460 IF (L3-L2) 480, 480, 520
  480 J = L3 - 1
      K = IL2 - L1
      J1 = IL2 - 1
      DO 500 I = 1, K
         A(J) = A(J1)
         IND(J) = IND(J1)
         J = J - 1
         J1 = J1 - 1
  500 CONTINUE
      IW1 = IW - 1
      IF (IW1) 400, 400, 360
  520 J = IL2 - 1
      K = L2 - 1
      N21 = IL2 - L1
      DO 540 I = 1, N21
         A(K) = A(J)
         IND(K) = IND(J)
         K = K - 1
         J = J - 1
  540 CONTINUE
      DO 560 I = 1, NN
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  560 CONTINUE
      L1 = K + 1
      GO TO 180
  580 IF (L3-N) 600, 600, 620
  600 IF (KOUNT(IKO-1)-NM-NM) 620, 620, 120
  620 IKO = IKO - 1
      NM = KOUNT(IKO)
      L1 = IST(IKO)
      GO TO 160
  640 K = K + 2
  660 IFAIL = P01ABF(IFAIL,K,SRNAME,0,P01REC)
      RETURN
  680 IND(1) = 1
  700 IFAIL = 0
      RETURN
      END
