	DOUBLE PRECISION FUNCTION POLAG(N,AL,X)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CALCULATES LAGUERRE POLYNOMIALS	
	A=1.
	IF(N.EQ.0) THEN
	POLAG=A
	RETURN
	END IF
	B=AL+1.d0-X
	IF(N.EQ.1) THEN
	POLAG=B
	RETURN
	END IF
	DO 1 I=2,N
	C=((2.d0*I+AL-1.d0-X)*B-(I+AL-1.d0)*A)/I
	A=B
1	B=C
	POLAG=C
	RETURN
	END
	DOUBLE PRECISION FUNCTION POLAGD(N,AL,X)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CALCULATES DERIVATIVE OF LAGUERRE POLYNOMIALS	
	IF(N.EQ.0) THEN
	  POLAGD=0.0
	ELSE
	  POLAGD=-POLAG(N-1,AL+1.d0,X)
	END IF
	RETURN
	END
	DOUBLE PRECISION FUNCTION dlagn(N,AL,X)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DOUBLE PRECISION LAGNORM
CALCULATES DERIVATIVE wrt X of NORMALISED LAGUERRE BASIS FUNCTIONS:
C    S(x) = L(x) * N * x^(alf/2)  * exp(-x/2)
C where x = r/step & N = lagnorm
	DLAGN = LAGNORM(N,AL) * X**(AL*0.5-1) * EXP(-X*0.5)
     X          * (X*POLAGD(N,AL,X) + POLAG(N,AL,X)*0.5d0*(AL-X))
	RETURN
	END
