      SUBROUTINE GG(K,L,M,L1,L2,X,TETA1,FI1,TETA2,FI2,OUT,KLMN)
C
C *****************************************************************
C ***                                                           ***
C ***  CALCULATIONS IN HYPERSPHERICAL POINTS:         = OUT     ***
C ***                                                           ***
C ***               WITHOUT READY INT. ARRAY   (KLMN=0)         ***
C ***               WITH    READY INT. ARRAY   (KLMN=1)                ***
C ***                                                           ***
C *****************************************************************
C
      IMPLICIT DOUBLEPRECISION(A-F,H,O-Z)
      COMMON/NJ/IT,G(302)
      COMMON/FACTOR/FACL(100),DFACL(100)
      S=DSQRT(X)
      C=DSQRT(1.D0-X)
      A=L1+0.5D0
      B=L2+0.5D0
      N=(K-L1-L2)/2
      XX=C*C-S*S
      CALL PJCOB(A,B,N,XX,PJ)
      N1=(K-L1-L2)/2
      F1=FACL(N1+1)
      F1=DEXP(F1)
      N2=(K+L1+L2)/2+1
      F2=FACL(N2+1)
      F2=DEXP(F2)
      KX1=K-L1+L2+3
      CALL GAMM(KX1,AG1)
      KX2=K+L1-L2+3
      CALL GAMM(KX2,AG2)
      ANORM=(2.D0*K+4.D0)*F1*F2/AG1/AG2
      ANORM=DSQRT(ANORM)
      IF(S.EQ.0.D0.AND.L1.EQ.0) SOL1=1.D0
      IF(S.EQ.0.D0.AND.L1.NE.0) SOL1=0.D0
      IF(S.NE.0.D0.AND.L1.NE.0) SOL1=S**L1
      IF(L1.EQ.0) SOL1=1.D0
      IF(C.EQ.0.D0.AND.L2.EQ.0) COL2=1.D0
      IF(C.EQ.0.D0.AND.L2.NE.0) COL2=0.D0
      IF(C.NE.0.D0.AND.L2.NE.0) COL2=C**L2
      IF(L2.EQ.0) COL2=1.D0
      OUT=SOL1*COL2*PJ*ANORM
      IF(KLMN.EQ.0) GO TO 432
      ANGPAR=0.D0
      MEN1=2*L1+1
      M1=-L1-1
      DO 843 MMM=1,MEN1
      M1=M1+1
      M2=M-M1
      MTEST=IABS(M2)
      IF(MTEST.GT.L2) GO TO 842
      EDIN=DSQRT(2.D0*L1+1.D0)*DSQRT(2.D0*L2+1.D0)/4.D0/3.141592654D0
      EDIN=EDIN*SFEFAN(L1,M1,TETA1,FI1)
      EDIN=EDIN*SFEFAN(L2,M2,TETA2,FI2)
      KUTA=L1+L2+M1+M2
      IF(KUTA.EQ.0) POWR=1.D0
      IF(KUTA.NE.0) POWR=(-1.D0)**KUTA
      ANGPAR=ANGPAR+EDIN*DSQRT(2.D0*L+1.D0)*WIG(2*L1,2*L2,2*L,2*M1,
     ,2*M2)*POWR
 842  CONTINUE
 843  CONTINUE
      OUT=OUT*ANGPAR
 432  CONTINUE
      RETURN
      END
      SUBROUTINE RRCOE(K,L,L1,L2)
C****  R.R. COEFFICIENTS OR HYPERSPH. BRACKETS ARE CALCULATED HERE
C****  WITH THE HELP OF EQS. (28),(47) IN YAD.FIZ. 17(1973)210 .
C****  L1 AND L2 ARE JACOBI MOMENTA.TWO JACOBI MOMENTA IN AN ANOTHER
C****  PAIR ARE DESIGNATED BELOW AS L11 AND L21. BRACKETS WITH ALL
C****  POSSIBLE L11,L12 VALUES AT GIVEN K,L,L1,L2 ARE CALCULATED.
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      COMMON/ROT/C,S,T,A(99,29),J1,J
      COMMON/FACTOR/ FACL(100),DFACL(100)
C****    QUANTITIES C,S,T,A,J1,J,FACL AND DFACL ARE DEFINED
C****  AS FOLLOWS.
C****  C = COS(FI), S = SIN (FI), T = TAN(FI) WITH
C****  KSI11 = -C*KSI1+S*KSI2, KSI21 = S*KSI1-C*KSI2, SEE EQ.(6)
C****  IN YAD.FIZ. 17(1973)210. THE H.H. ARE DEFINED AS IN EQS.
C****  (1) - (4) IN THAT PAPER.
C      A = A(M,N) IS A REQUIRED ARRAY OF BRACKETS WITH GIVEN K,L,L1,L2
C      VALUES. M AND N VARIABLES SPECIFY
C      OTHER PAIR OF JACOBI MOMENTA L11 AND L21 AS FOLLOWS
C      L11 = .5*(K-(L-NN))+N-M, L21 = .5*(K+(L-NN)-N-M+2.
C      THE NN VALUE EQUALS 0 IF K-L IS EVEN AND 1 OTHERWISE.
C      THE M AND N VARIABLES TAKE ALL THE INTEGER VALUES FROM
C      UNITY TO J1=.5*(K-L-NN)+1 AND J=L-NN+1 CORRESPONDINGLY
C      THAT GIVES ALL THE L11 AND L12 VALUES PERMISSIBLE
C****  AT GIVEN K,L,L1 AND L2.
C****  FACL(N)=LN((N-1)!), DFACL(N)=LN((2N-1)!!).
      DIMENSION B(99,29)
C****  THE B ARRAY IS AN AUXILIARY ONE.
C****  DIMENSIONS OF ARRAYS A(I1,I) AND B(I1,I) SHOULD BE NOT LESS
C****  THAN I1=J1=.5(K-L-NN)+1 AND I=J = L-NN+1 WITH J1 AND J DEFINED
C****  ABOVE.
      AL(JP,JQ,LX) =DSQRT((JP+JQ+LX)*(JP+JQ+LX+1.D0)*(JP+JQ-LX)*
     1(JP+JQ-LX-1.)/((2.*JP-1.)*(2.*JP+1.)*(2.*JQ-1.)*(2.*JQ+1.)))
      BE(JP,JQ,LX) = DSQRT((LX+JP-JQ+1.D0)*(LX+JP-JQ+2.)*(LX+JQ-JP)*
     1(LX+JQ-JP-1.)/((2.*JP+1.)*(2.*JP+3.)*(2.*JQ-1.)*(2.*JQ+1.)))
C  EQ.(48) ***********************************************
C            CALCULATION OF BR.OF EQ.(28)
      P1=DSQRT((2.D0*L1+1.D0)*(2.D0*L2+1.D0))
      P=FACL(L1+L2+2)+.5D0*(FACL(L1+L2+L+2)+
     1FACL(L1+L2-L+1))
      NNKL=K-L
      NN = NNKL-2*(NNKL/2)
      IF(NNKL) 31,30,30
  31  WRITE(6,40) K,L
      STOP
  30  LDIF=IABS(L1-L2)
      IF(L1+L2-L) 32,33,33
  32  WRITE(6,41) L1,L2,L
      STOP
  33  IF(L1+L2-K) 35,35,34
  34  WRITE(6,42) L1,L2,K
      STOP
  35  KPAR=K-2*(K/2)
      L12PAR=L1+L2-2*((L1+L2)/2)
      IF(KPAR-L12PAR) 36,37,36
  36  WRITE(6,43) L1,L2,K
  40  FORMAT(' CHECK K AND L VALUE. K=',I4,' L=',I4)
  41  FORMAT(' CHECK L1,L2 AND L VALUE. L1=',I4,' L2=',I4,' L=',I4)
  42  FORMAT(' CHECK L1,L2 AND K VALUE. L1=',I4,' L2=',I4,' K=',I4)
  43  FORMAT(' CHECK PARITY L1+L2 & K. L1=',I4,' L2=',I4,' K=',I4)
      STOP
  37  IF(L-LDIF) 32,38,38
  38  LL = L-NN
      J1 = (L1+L2-L-NN)/2 +1
      J  = LL+1
      DO 1 M=1,J1
      DO 1 N=1,J
      L11 = (L1+L2-LL)/2+N-M
      L21 = (L1+L2+LL)/2-N-M+2
      LS1  = (L1+L2-L11-L21)/2
      LT1  = (L1+L2+L11+L21)/2
      Q1=DSQRT((2.D0*L11+1.D0)*(2.D0*L21+1.D0))
      Q=FACL(LS1+1)+FACL(LT1+2)+DFACL(LS1+L11+1)+DFACL(LS1+L21+1)
C EQ.(29)    *************************************************
      F  = 0.000D0
      LP1 = L1-LS1
      LQ1 = L2-LS1
      I1 = IABS(LP1-L11)+1
      I2 = MIN0(LP1+L11,LQ1+L21)+1
      DO 2 MM=I1,I2,2
      LZ1  = L11-MM+1
      LZ2  = MM-L21-1
      LX1  = (LP1+LZ1)/2
      LX2  = (LP1-LZ1)/2
      LX3  = (LQ1+LZ2)/2
      LX4  = (LQ1-LZ2)/2
 2    F=F+(-1)**LX4*DEXP(.5*(FACL(2*LX1+1)+FACL(2*LX2+1)+
     1FACL(2*LX3+1)+FACL(2*LX4+1))-FACL(LX1+1)-FACL(LX2+1)-
     2FACL(LX3+1)-FACL(LX4+1))*T**(MM-1)*
     3 WIG(2*LP1,2*LQ1,2*L,2*LZ1,2*LZ2)
      I   = -(L11+L21)
      A(M,N)=S**LS1*C**LT1*2.D0**I*P1*Q1*DEXP(P-Q)*F
 1    B(M,N) = A(M,N)
      K1  = L1 + L2 +2
      IF(K-K1)25,4,4
 4    C2  = C**2 -S**2
      S2  = S*C
C  EQ. (47), SEE LABEL 19 IN BELOW  ***************************
      DO 5 I=K1,K,2
      J1   = J1 +1
      LP11  = (I-LL)/2
      LP21  = (I+LL)/2
      DO 6 M=1,J1
      DO 6 N=1,J
      L11  = LP11+N-M
      L21  = LP21 -N-M+2
      IF(M-2) 7,8,9
 7    A1   = 0.0000000
      A3   = 0.0000000
      A4   = 0.0000000
      A5   = 0.0000000
      GO TO 10
 8    A3   = 0.0000000
      GO TO 11
 9    A3   = B(M-2,N)*AL(L11+1,L21+1,L)
 11   A1   = B(M-1,N)
      IF(N-1)12,12,13
 12   A5   = 0.00000000
      GO TO 14
 13   A5   = B(M-1,N-1)*BE(L21,L11,L)
 14   IF(J-N) 15,15,16
 15   A4   = 0.00000000
      GO TO 10
 16   A4   = B(M-1,N+1)*BE(L11,L21,L)
 10   IF(J1-M) 17,17,18
 17   A2   = 0.0000000
      GO TO 19
 18   A2   = B(M,N)*AL(L11,L21,L)
 19   A(M,N) = C2*A1+S2*(A2-A3+A4-A5)
  6   CONTINUE
      DO 26 M=1,J1
      DO 26 N=1,J
      B(M,N) = A(M,N)
  26  CONTINUE
  5   CONTINUE
C  EQ.(12) *********************************************************
 25   CCC   =.5D0*(FACL(1+(K-L1-L2)/2)+
     1FACL(2+(K+L1+L2)/2)+DFACL((K-L1+L2+2)/2)+
     2DFACL((K+L1-L2+2)/2))
      LP11  = (K-LL)/2
      LP21  = (K+LL)/2
      DO 20 M=1,J1
      DO 20 N=1,J
      L11  = LP11+N-M
      L21  = LP21-N-M+2
      FAFUN   =.5D0*(FACL(1+(K-L11-L21)/2)+
     1FACL(2+(K+L11+L21)/2)+DFACL((K-L11+L21+2)/2)+
     2DFACL((K+L11-L21+2)/2))
      A(M,N)=A(M,N)*DEXP(FAFUN-CCC)
 20   CONTINUE
      RETURN
      END
      SUBROUTINE PJCOB(A,B,N,X,PJ)
C
C **************************************************************
C ***                                                        ***
C ***  JACOBI POLIN. CALCULATION                = PJ         ***
C ***                                                        ***
C **************************************************************
C
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      NN=N+1
      M=-1
      PJ=0.D0
      DO 1 K=1,NN
      M=M+1
      P=N+A
      CALL COEF(P,M,CO1)
      PP=N+B
      MM=N-M
      CALL COEF(PP,MM,CO2)
      XMIN=X-1.D0
      XPLU=X+1.D0
      IF(M.NE.0.AND.XPLU.NE.0.D0) XPLU=XPLU**M
      IF(M.NE.0.AND.XPLU.EQ.0.D0) XPLU=0.D0
      IF(M.EQ.0) XPLU=1.D0
      IF(MM.NE.0.AND.XMIN.NE.0.D0) XMIN=XMIN**MM
      IF(MM.NE.0.AND.XMIN.EQ.0.D0) XMIN=0.D0
      IF(MM.EQ.0) XMIN=1.D0
 1    PJ=PJ+1.0D0/2.0D0**N*CO1*CO2*XMIN*XPLU
      RETURN
      END
      SUBROUTINE COEF(P,M,CO)
C
C ***********************************************************
C ***                                                     ***
C ***  CALCUL. OF COEFFICIENTS   / P \                    ***
C ***                            \ M /                    ***
C ***                                                     ***
C ***********************************************************
C
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      COMMON/FACTOR/FACL(100),DFACL(100)
      CO=0.D0
      IF(M.EQ.0) CO=1.D0
      IF(M.EQ.0) GO TO 111
      IF(M.LT.0) GO TO 112
      IF(M.EQ.1) CO=P
      IF(M.EQ.1) GO TO 111
      GO TO 114
 112  CONTINUE
      WRITE(6,1)
C     WRITE(5,1)
  1   FORMAT(/5X,' (P/M) - M NEGATIVE'/)
      GO TO 111
114   CONTINUE
      FM=FACL(M+1)
      FM=DEXP(FM)
      MM=-1
      CO=1.D0/FM
      DO 55 K=1,M
      MM=MM+1
55    CO=CO*(P-MM)
 111  CONTINUE
      RETURN
      END
      SUBROUTINE GAMM(KX,GAM)
C
C **************************************************************
C ***                                                        ***
C ***  GAMMA-FUNCTION CALC.                                  ***
C ***                                                        ***
C **************************************************************
C
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      COMMON/FACTOR/FACL(100),DFACL(100)
      GAM=0.D0
      N=(KX-1)/2
      IF(N.EQ.0.OR.N.EQ.1) FF=1.D0
      IF(N.EQ.0.OR.N.EQ.1) GO TO 111
      IF(N.LT.0) GO TO 112
      GO TO 114
 112  CONTINUE
C++   WRITE (7,115)
      WRITE (6,115)
 115  FORMAT(/5X,'  DOUBLE FACTORIAL FROM NEGATIVE VALUE '/)
      FF=0.D0
      GO TO 111
 114  CONTINUE
C     L=2.D0*N-1.D0+1.D0
      FF=DFACL(N)
      FF=DEXP(FF)
 111  CONTINUE
      GAM=DSQRT(3.141592654D0)*FF/2.D0**N
      RETURN
      END
      SUBROUTINE LOGFAC(NPEAR1,NPEAR2,INININ)
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      COMMON/ROT/CC,S,T,A(99,29),J1,J
      COMMON/FACTOR/FACL(100),DFACL(100)
      COMMON/MASES/AM1,AM2,AM3
      DIMENSION AMAM(3)
      IF(INININ.EQ.0) GO TO 111
C
C *************************************************
C     FACL(N)=LN((N-1)!)
C     DFACL(N)=LN((2N-1)!!)
C *************************************************
C
      FACL(1)=0.D0
      DFACL(1)=0.D0
      DO 90 I=2,100
      FACL(I)=FACL(I-1)+DLOG(I-1.D0)
 90   DFACL(I)=DFACL(I-1)+DLOG(2.D0*I-1.D0)
 111  AMAM(1)=AM1
      AMAM(2)=AM2
      AMAM(3)=AM3
      AMAMA=AM1+AM2+AM3
      T=AMAMA*(AMAMA-AMAM(NPEAR1)-AMAM(NPEAR2))/AMAM(NPEAR1)/
     /AMAM(NPEAR2)
      T=DSQRT(T)
      CC=1.D0/(1.D0+T*T)
      S=1.D0/(1.D0+1.D0/T/T)
      CC=DSQRT(CC)
      S=DSQRT(S)
      RETURN
      END
      FUNCTION SFEFAN(LURA,MURA,TETURA,FIURA)
C
C **************************************************************
C ***                                                        ***
C *** SPHERICAL FUNCTIONS CALC.                              ***
C ***       ( PABEH 0 OR  180, T.E.  REAL)                   ***
C ***                                                        ***
C **************************************************************
C
      IMPLICIT DOUBLEPRECISION(A-F,H,O-Z)
      COMMON/NJ/IT,G(302)
      DIMENSION I(4)
      EQUIVALENCE (I(1),I1),(I(2),I2),(I(3),I3),(I(4),I4)
      AJ=LURA
      AM1=IABS(MURA)
      AM2=0.D0
      ANGL=TETURA
C **************************************************************
C ***  CALCULATION OF D-FUNCTIONS (GRATE)                    ***
C ***                                                        ***
C ***       NOTE: GRATE - BUT WITH FI = 0 OR 180 DEGREES     ***
C **************************************************************
      ROLL=0.D0
      IF(IT-20431) 10,30,10
 10   IT=20431
      G(1)=0.D0
      G(2)=0.D0
      DO 20 J=3,302
      X=J-1
      GXXXX=X
 20   G(J)=G(J-1)+ALOG(GXXXX)
 30   J1=2.D0*AJ+0.1D0
      M1=2.D0*AM1+0.1D0
      M2=2.D0*AM2+0.1D0
      I(1)=J1+M1
      I(2)=J1-M1
      I(3)=J1+M2
      I(4)=J1-M2
      DO 50 J=1,4
      K=I(J)/2
      IF(I(J)-2*K) 300,40,300
 40   IF(K) 300,50,50
 50   I(J)=K+1
      Y=ANGL/2.0D0
      X=DCOS(Y)
      Y=DSIN(Y)
      IL=1
      IF(I3-I1) 150,150,140
 140  IL=I3-I1+1
 150  IN=I2
      IF(I3-I2) 160,170,170
 160  IN=I3
 170  C=(G(I1)+G(I2)+G(I3)+G(I4))/2.D0
      S=0.D0
      ST=1.D0
      DO 180 J=IL,IN
      J1=I2-J+1
      J2=I3-J+1
      J3=J
      J4=I1-I3+J
      J5=I2+I3-2*J
      J6=I1-I3+2*(J-1)
      A1=1.D0
      IF(J5) 300,173,171
 171  DO 172 L=1,J5
 172  A1=A1*X
 173  A2=1.D0
      IF(J6) 300,176,174
 174  DO 175 L=1,J6
 175  A2=A2*Y
 176  CONTINUE
      S=S+ST*A1*A2*DEXP(C-G(J1)-G(J2)-G(J3)-G(J4))
 180  ST=-ST
      K=(IL-1)/2+0.1D0
      IF(IL-1-2*K) 190,200,190
 190  S=-S
 200  ROLL=S
 300  CONTINUE
      LEMURA=IABS(MURA)
      AKOT=1.D0
      IF(MURA.LT.0) AKOT=(-1.D0)**LEMURA
      SFEFAN=ROLL*DCOS(FIURA*MURA)*AKOT
      RETURN
      END
