C       STURMX:
c       Using Sturmians/Energy-eigenstate to solve the 3-body problem 
c	for bound and scattering states
c	 e.g. Hypersphericals using Sturm-Laguerre basis
c
c
	Subroutine Sturmians(Nstate,Nstate3)
      	use globals
      	use pauli
      	use gs
      	use scattering
	implicit real*8 (a-h,o-z)
        real*8 VVsturm(numrmax),Rmat(MCHAN3,MCHAN3)
	real*8 alpha(nchmax),Abound(MEIGS)
        real*8,allocatable:: AA(:,:),MM(:,:),SS(:,:),phi(:,:),VEC(:,:)
C						NB: the norm matrix MM is
C						really block diagonal, and
C						should be stored like
C						MM(nmax,nmax,MCHAN)!
	integer icount(nchmax)
	real*8 VAL(0:MEIGS),VALI(0:nchmax)
	logical ival,esturm,logic(nchmax)
	dimension  D1(nchmax),D2(nchmax),failed(nchmax),
     x		ebutc(nmaxb,MCHAN3,2),nebut(MCHAN3)
	real cfp(max(1,ipmax))
	real*8 tim(0:7)

	tim(0:7) = second()
c				Select some maximum energy
	E1 = max(ESCATT,emax,1d0)
	WVK  = SQRT(E1/ryev)
c				Select some typical incoming channel
	 j = 1
	 if(mintl>0) j = initl(1)
	 	cfp(1) = 0d0
	  	do np=1,npots
	    	 cfp(1) = cfp(1) + cf(j,j,1,np) * potcoef(np)
   	  	enddo
         ETA = cfp(1) / (WVK+WVK)
        RTURN =(ETA+SQRT(ETA**2 + JTOT*(JTOT+1)))/WVK
	nsturm = nsturmi
!	rafin  = (rafini + 3*rafin)/4.
	rafin  = rafini
	Rmax = Rmaxi
	if(tinside>0) then
	  write(IOUT,3) JTOT,E1,j,RTURN
3	  format('    For J =',F6.1,' at E =',f8.3,', ch. ',i3,
     X	   ' has turning point at ',f8.2)
	  if(RTURN>Rmax+tinside) then
	  nsturm=0
	  buttle=0
	  neigs=0
	  Rmax=min(RTURN-tinside,rafin)
	  write(IOUT,4) tinside,Rmaxi+tinside,Rmax
4	  format('    Since this is outside Rmax + ',f7.2,' =',f8.2,
     X     ', use ADW at',f8.2/)
	  endif
	endif
	nch=nsturm*Nstate
        allocate (AA(nchmax,nch),MM(nch,nch))
        allocate (VEC(nchmax,0:min(nch,MEIGS)),SS(nchmax,numrmax))
	symm = .not.fad
	EBND=egsmin
	if(nch.eq.0) then
	  allocate (phi(MCHAN,1))
	  deallocate (MM)
	  tim(1:7) = second()
	  go to 55
	 endif
	do 5 k=1,nch
5	alpha(k) = 0.0
	ival = .false.
c	write(6,*) 'Sturmhh: kst=',kst,sturm(kst)
C				radial grid for diagonalising
	k = 0
	call chopb(20)
	read(20,end=15,err=15) sturm(kst),neigs
	onormal = sturm(kst).ne.'T' 
	write(6,*) 'To read ',neigs,' eigensolutions from file 20'
	do 10 k=1,neigs
10	read(20,end=15,err=15) alpha(k),VAL(k),(VEC(i,k),i=1,nch)
	write(6,*) 'Read ',neigs,' eigensolutions from file 20',k
        call Basis(Nstate,SS,alpha,VVsturm,.true.,ebutc,nebut,
     x		    Nstate3,esturm,failed)
		tim(1:7) = second() 
	call flush(6)
        call MakeMatrix(Nstate,alpha,SS,VVsturm,AA,MM,.true.,
     x                  D1,D2,esturm,failed)
		tim(2:7) = second() 
	Go to 30

15	write(6,*) ' Calculate basis wave functions:'
	call flush(6)
 	if(k.ne.0) write(6,*) 'Read only ',k-1,' eigensolutions',
     &                       ' from file 20'
	onormal = sturm(kst).ne.'T' 
c	onormal = .false.
C*******
C*******  Do full calculation:

        call Basis(Nstate,SS,alpha,VVsturm,.false.,ebutc,nebut,
     x		    Nstate3,esturm,failed)
		tim(1:7) = second() 
	write(6,*) ' Calculate matrix elements:'
	call flush(6)
        call MakeMatrix(Nstate,alpha,SS,VVsturm,AA,MM,.false.,
     x                  D1,D2,esturm,failed)
		tim(2:7) = second() 
	if(simeq) then
	  neigs=0
	  write(6,*) ' Linear equations for one scattering energy'
	  allocate (phi(1,1))
           if(asymp) then
C **                            Initialise xlr arrays:
             write(6,'(/'' Initialise xlr coupled wfns:'')')
             NR = numrs - numrs1 + 1
	     call xlrin(Rmax,Nstate,Rmax*beta,.true.,steps,NR)
	    endif
	  go to 80
	endif
	write(6,*) ' Diagonalise:'
	call flush(6)
C					invitr is more stable if symm=F
 	symm = .false.
	neigs = nch - nsrc
	if(neigs.lt.1) then
		write(6,*) ' TOO MANY ORTHOGONALITY CONSTRAINTS!'
		stop
		endif
c	neigs = nch
	if(ngsmax.le.0) ngsmax = nch
	de = (egsmax-egsmin)*0.25
	if(FAD) then
	  if(ngsmax.eq.1 .or. nccset.eq.1.and.estep.lt.0.) then
C use inverse iteration 
	   	neigs = 1
		write(6,*) ' Find eigensolution nearest ',real(egsmin)
		call flush(6)
	   	call invitr(AA,nchmax,nch,MM,nchmax,symm,onormal,nsturm,
     &                 VAL(1:MEIGS),VEC(1,1),egsmin,de,1d-5,30)
	        call enorm(VEC(1,1),nchmax,neigs,WN1,MCHAN,VAL(1:MEIGS),
     x				SS,numr,nch,nsturm,wrad,AA,D1,.false.)
c
	  else if(.not.onormal) then
C find all eigensolutions of unsymmetric matrix problem Ax=EBx
C with F02BJF
		stop 'F02BJF'

	  else 
C find all eigensolutions of unsymmetric matrix problem Ax=Ex
C with F02AGF
		if(nchmax.gt.MEIGS) go to 99
		write(6,*) ' Find ',nch,' eigensolutions'
		call flush(6)
          	call f02agfr(AA,nchmax,nch,VAL(1:MEIGS),VALI(1:MEIGS),
     x                  VEC(1,1),nchmax,.false.,icount,IFAIL)
		ival = .true.
      	        call enorm(VEC(1,1),nchmax,neigs,WN1,MCHAN,VAL(1:MEIGS),
     x				SS,numr,nch,nsturm,wrad,AA,D1,.true.)
	 endif
	else 
c					NOT Faddeev equations:
	if(.not.onormal) then
	       if(ngsmax.eq.1.or.nccset.eq.1.and.estep.lt.0.) then
C Ax=EBx  	lowest eigensolution only 
	   	neigs = 1
		write(6,*) ' Find eigensolution nearest ',real(egsmin)
		call flush(6)
	   	call invitr(AA,nchmax,nch,MM,nchmax,symm,onormal,nsturm,
     &                 VAL(1:MEIGS),VEC(1,1),egsmin,de,1d-5,30)
	       else
C Ax=EBx all
		write(6,*) ' Find ',nch,' generalised eigensolutions'
	   	call F02AEF(AA,nchmax,MM,nchmax,nch,
     &  	    VAL(1:MEIGS),VEC(1,1),nchmax,D1,D2,IFAIL)
			do 21 i=1,nch
			do 21 j=1,i-1
  21			MM(i,j) = MM(j,i)
  		write(6,*) '   IFAIL = ',IFAIL, '  meigs=',meigs
	       endif
	  else if(ngsmax.eq.1 .or.nccset.eq.1.and.estep.lt.0.) then
C Ax=Ex  lowest eigensolution only
	   neigs = 1
		write(6,*) ' Find eigensolution nearest ',real(egsmin)
		call flush(6)
	   call invitr(AA,nchmax,nch,MM,nchmax,symm,onormal,nsturm,
     &                 VAL(1:MEIGS),VEC(1,1),egsmin,de,1d-5,30)
!	  else if(ngsmax.gt.nch*0.25.and.eeigmax.lt.emax) then
!	  else if(ngsmax.gt.min(nch*0.25,MEIGS).and.eeigmax>4999.) then
 	  else if(ngsmax.gt.min(nch/4,MEIGS).and.eeigmax>999.) then
C Ax=Ex all
		if(nchmax.gt.MEIGS) go to 99
		write(6,*) ' Find ',nch,' eigensolutions'
		call flush(6)
	   call F02ABF(AA,nchmax,nch,VAL(1:MEIGS),VEC(1,1),nchmax,
     &			D1,IFAIL)

	  else 
C Ax=Ex selected eigensolutions
c							'F02BBF'
!                        if(nchmax.lt.9) stop 'nchmax 9'
	   if(nchmax.lt.MEIGS.and.eeigmax.le.0.1) eeigmax = 30.0
	   emeig = max(egsmax,eeigmax)
	   neiglook = min(ngsmax,MEIGS)
	   if(eeigmax.gt.0) neiglook = MEIGS
	   	  
22	   IFAIL=0
		write(6,*) ' Find ',neiglook,' eigensolutions'
		call flush(6)
           call F02BBF(AA,nchmax,nch,egsmin,emeig,neiglook,neigs,
     x                	VAL(1:MEIGS),VEC(1,1),nchmax,D1,D2,
     x                	MM(1,1),MM(1,3),MM(1,2),logic,icount,IFAIL)
                        do 24 i=1,nch
                        do 23 j=1,nch
23                      MM(i,j) = 0d0
24                      MM(i,i) = 1d0
	   if(neigs.lt.nch)  then
	     write(6,26) egsmin,emeig,neigs,nch,MEIGS
26	   format('  Between ',F6.1,' &',F7.1,' MeV,',I4,' /',I6,
     X		  ' eigenvalues found; room for', I6)
!	   else
	   endif
	     T = 0d0
	     if(neigs>0) then
	      write(6,'(''  Largest eigenvalue ='',f10.3)') VAL(neigs)
	      T = VAL(neigs)*0.8
	     endif
!	     if(doscat.and.EMAX>T.or.ESCATT>T) then
!	       write(6,*) ' NOT ENOUGH EIGENSTATES FOR SCATTERING!'
!	       stop
!	     endif
!				Help for next time:
!	     if(neigs<10.and.ESCATT>0) eeigmax = eeigmax+50
             
	     if(neigs.eq.0.and..not.GO) write(6,*) 'NO g.s. ENGY found!'
	   endif
	endif
	if(neigs.lt.5.and.fadex.ge.2) then
	call chopb(21)
	write(21) sturm(kst),neigs
	do 25 k=1,neigs
25	write(21) alpha(k),VAL(k),(VEC(i,k),i=1,nch)
	write(6,*) 'Written ',neigs,' eigensolutions to file 21'
	endif
30	continue 
	if(.not.fad) then
C	  Copy MM to AA, as WN1=I and so AA is block-diagonal same as MM:
	  do 40 i=1,nch
	  do 40 j=1,nch
40	   AA(i,j) = MM(i,j)
C				(if fad, AA is constructed in enorm)
	 endif
		tim(3:7) = second() 
		deallocate (MM)
		itmax=3

	if(EEIGMAX.gt.0..and.VAL(neigs).gt.EEIGMAX) then
c			Forget eigenstates above E = EEIGMAX
	 do 41 k=neigs,1,-1
41	  if(VAL(k).lt.EEIGMAX) go to 42
42	 neigs = k
	 write(6,43) neigs,VAL(neigs)
43	 format('  ONLY',I6,' eigenstates kept (largest =',F10.4,')')
        endif

	allocate (phi(MCHAN,neigs))
	EBND = 1d5
	if(neigs.gt.0) then
c                       Find eigenstate strengths at the R-matrix boundary:
        do 51 k=1,neigs
	  do 45 i=1,Nstate3
45	  D1(i) = 0.0
          do 50 i=1,Nstate3
             phi(i,k)=0d0
          do 50 j=1,Nstate
	     if(fadex.eq.1) then
	       T = WN1(i,j)
c	       if(KFAD(i).gt.1) T = T*0.5
	     else
c	if fadex=2 or 3, rmatrix & contwf do own transformations
	       T = 0.0
	       if(i.eq.j) T = 1.0
	     endif
	    if(abs(T).gt.1e-8) then
             do 49 n1=1,nsturm
                nn1=n1+(j-1)*nsturm
                CON = VEC(nn1,k)*SS(nn1,numr) * T
                D1(i)=D1(i)+CON
49              phi(i,k)=phi(i,k)+CON
	    endif
50	  continue
c	if(VAL(k).lt.10.0) 
c    x	 write(149,5051) k,VAL(k),(D1(i),i=1,min(10,Nstate3))
5051	 format(' At',i5,f8.3,': phi terms =',10f8.4)
	 EBND = min(VAL(k),EBND)
51	  continue

c               Write out R-matrix parameters, for eg. resonance searching.
        if(prrexp) then
	  call chops(150)
          write(150,*) Nstate3,neigs,ryev,rmax,scent,beta
          write(150,*) (LCHL(i),i=1,Nstate3)
          do k=1,neigs
            write(150,'(1p,6e16.8)') VAL(k),(phi(i,k),i=1,Nstate3)
          enddo
!	  call chops(151)
	  write(150,*) nsturm,numr,stepi,eeigmax,pertcent
	  do i=1,Nstate3
	   write(150,*) i
	   write(150,'(1p,6e14.6)') (VVAL(i,i,n*stepi),n=1,numr)
	   do n=1,nsturm
	     k = (i-1)*nsturm+n
	   write(150,'(2g16.8)') alpha(k),SS(k,numr)
	   enddo
	  enddo
	  write(150,*) ipmax
	  do i=1,Nstate3
	  do j=1,Nstate3
	    do ip=1,ipmax
	    cfp(ip)= 0d0
	    do np=1,npots
	     cfp(ip) = cfp(ip) + cf(i,j,ip,np) * potcoef(np)
	     enddo
	    enddo
	   write(150,'(2i4,5g16.8)') i,j,cfp
	   enddo
	  enddo

	  call flush(150)
	  write(6,*) ' R-matrix parameters written to files 150'
        endif
        endif
***************		come here directly if nsturm=nch=0
55	continue

	if(allocated(PsiGSe)) deallocate (PsiGSe)
	allocate (PsiGSe(Nstate,numrs))
        if(asymp .and. (xlrgs.or.GO) )  then
C **                            Initialise xlr arrays:
           write(6,'(/'' Initialise xlr coupled wfns:'')')
           NR = numrs - numrs1 + 1
c
	   call xlrin(Rmax,Nstate,Rmax*beta,.true.,steps,NR)
	  endif
	leig = 1
		tim(4:7) = second() 
        if(asymp.and..not.GO.and.EBND.lt.0.0.and.xlrgs.and.ESCATT<.1) 
     X			then
        EBND = 1d10
	call boundx(Rmax,Rmat,Nstate,neigs,VAL(1:MEIGS),phi,
     x	            PsiGSe(:,numrs1:numrs),
     x              steps,NR,Abound,NPOLE,EBND)
	 if(EBND.lt.1d9) then
	   leig = 0
	   VAL(leig) = EBND
	   VALI(leig) = 0.0
	   do 60 nn1=1,nch
	    VEC(nn1,leig) = 0.0
	    do 60 k=1,neigs
60	    VEC(nn1,leig) = VEC(nn1,leig) + Abound(k)*VEC(nn1,k)
		write(6,*) ' BOUNDX eig at ',real(EBND)
	 else
	  write(6,*) ' BOUNDX did not find a bound state!'
	 endif
	else
		tim(4:7) = second() 
        endif
		tim(5:7) = second() 

	if(egsmax>egsmin)  then
        call Probability(VAL,VEC,SS,AA,VALI,ival,icount,
     x			Nstate,Abound,leig,NPOLE)
	else
	  call chops(15)
	  do k=leig,neigs
 	  if(.not.ival) write(15,*) k,VAL(k)
 	  if(ival)      write(15,*) k,VAL(k),VALI(k)
	  enddo
	    write(15,*) '&'
	endif
	deallocate (AA)
		allocate (AA(1,1))
      	    
80		tim(6:7) = second() 
	call flush(6)
	if(doscat.or.ESCATT>1e-5)
     &  call Scatter(Nstate,Nstate3,SS,alpha,VAL(1),VEC(1,1),
     & 		ebutc,nebut,esturm,VVsturm,phi,Rmat,AA)
		deallocate (SS,phi,VEC)
		deallocate (AA)
		tim(7) = second() 
	call flush(6)
		itmax=7
90	write(6,95) second()-tim(0),(tim(i)-tim(i-1),i=1,itmax)
95 	format(/' Times     Total=    basis+   matrix+     diag+   ',
     &          ' xlrin+    boundx+   g.s.+    scattering',/
     &          ' Secs:',8f10.3)
	call flush(6)
  	return
99	write(6,*) 'Need MEIGS =',nchmax,' but only have ',MEIGS
	stop
	end
