      SUBROUTINE DGEDT (A,LDA,N,IPVT,DET)
      INTEGER LDA,N,IPVT(N)
      DOUBLE PRECISION A(LDA,N),DET(2)
c
c     DGEDT computes the determinant a matrix
c     using the factors computed by DGETRS
c     on entry:
c
c        a       double precision(lda, n)
c                the output from DGETRS
c        lda     integer
c                the leading dimension of the array  a .
c        n       integer
c                the order of the matrix  a .
c        ipvt    integer(n)
c                the pivot vector from dgeco or dgefa.
c     on return:
c        det     double precision(2)
c                determinant of original matrix if requested.
c                determinant = det(1) * 10.0**det(2)
c                with  1.0 .le. abs(det(1)) .lt. 10.0
c                or  det(1) .eq. 0.0 .
c
      DOUBLE PRECISION TEN,ZERO,ONE
      INTEGER I
      PARAMETER (ZERO=0.0D0,ONE=1.0D0,TEN=10.0D0)
*     
      DET(1) = ONE
      DET(2) = ZERO
      DO 50 I = 1, N
         IF (IPVT(I) .NE. I) DET(1) = -DET(1)
         DET(1) = A(I,I)*DET(1)
*     ...exit
         IF (DET(1) .EQ. ZERO) GO TO 60
   10    IF (ABS(DET(1)) .GE. ONE) GO TO 20
         DET(1) = TEN*DET(1)
         DET(2) = DET(2) - ONE
         GO TO 10
   20    CONTINUE
   30    IF (ABS(DET(1)) .LT. TEN) GO TO 40
         DET(1) = DET(1)/TEN
         DET(2) = DET(2) + ONE
         GO TO 30
   40    CONTINUE
   50 CONTINUE
   60 CONTINUE
*     
      RETURN
      END
      SUBROUTINE CPARM (NCHAN,ECORES,LCHL,ETH,E0,ryev,PR)
      IMPLICIT INTEGER (A-Z)
      REAL*8 ATRY,ECORES,ETH,E0,ryev
      PARAMETER ( NCOL=3 )
      COMMON /IO/ IIN,IOUT
      LOGICAL PR
      DIMENSION ECORES(NCHAN),LCHL(NCHAN),ETH(NCHAN)
*
*     CPARM : Channel parameters ETH, LCH
*
c			NB: Energies are now in MeV, not in Hartrees!
	ATRY = 1d0/ryev
!     E0 = ETARG(1)
      E0 = 0d0
      if(PR) WRITE (3,1000) E0
      DO 10 I = 1, NCHAN
         ETH(I) = ATRY * ( ECORES(I) - E0 )
   10 CONTINUE
	if(.not.PR) return
      DO 30 I = 1, NCHAN, NCOL
         II = MIN(I+NCOL-1,NCHAN)
         WRITE (3,1010) (J,LCHL(J),ETH(J),J=I,II)
   30 CONTINUE
      RETURN
*
 1000 FORMAT (' CPARM: E0 =',F13.8,/,' Channel Momenta, Thresholds :')
 1010 FORMAT (3(I4,I5,F16.8))
      END
      FUNCTION MAXL (NCHAN,L2P)
      IMPLICIT INTEGER (A-Z)
      DIMENSION L2P(NCHAN)
      LMAX = -1
      DO 10 I = 1, NCHAN
         LMAX = MAX(LMAX,L2P(I))
   10 CONTINUE
      MAXL = LMAX
      RETURN
      END
      FUNCTION CFX (NCHAN,SMAX,CF,MCHAN)
      IMPLICIT INTEGER (A-Z)
      REAL*8 CF,COEF,CFX,ZERO
      PARAMETER ( ZERO=0.0D0 )
      DIMENSION CF(MCHAN,MCHAN,SMAX)
*
      COEF = ZERO
      DO 30 K = 1, SMAX
         DO 20 J = 1, NCHAN
            DO 10 I = 1, NCHAN
               COEF = MAX( COEF, ABS(CF(I,J,K)) )
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      CFX = COEF
      RETURN
      END
      SUBROUTINE WRTTMT (A,N,NCOL)
      IMPLICIT INTEGER (A-Z)
      REAL*8 A
      COMMON /IO/ IIN,IOUT
      DIMENSION A(*)
*
*     WRTMAT : PRINTS AN N*N MATRIX STORED IN A LOWER TRIANGULAR ARRAY
*
      NF = 0
      DO 40 K = 1, N
         NTIM = K / NCOL
         IF ( NTIM .GT. 0 ) THEN
            DO 20 I = 1, NTIM
               NI = NF + 1
               NF = NF + NCOL
               WRITE (IOUT,1000) (A(KK),KK = NI,NF)
   20       CONTINUE
         ENDIF
         IRES = MOD(K,NCOL)
         IF ( IRES .GE. 1 ) THEN
            NI = NF + 1
            NF = NF + IRES
            WRITE (IOUT,1000) (A(KK),KK = NI,NF)
         ENDIF
c        WRITE (IOUT,1010)
   40 CONTINUE
      RETURN
*
 1000 FORMAT (15G16.7)
 1010 FORMAT (/)
      END
      SUBROUTINE WRTTMTR(A,N,NCOL,R)
      IMPLICIT INTEGER (A-Z)
      REAL*8 A,R
      COMMON /IO/ IIN,IOUT
      DIMENSION A(*)
*
*     WRTMAT : PRINTS AN N*N MATRIX STORED IN A LOWER TRIANGULAR ARRAY
*
      NF = 0
      DO 40 K = 1, N
         NTIM = K / NCOL
         IF ( NTIM .GT. 0 ) THEN
            DO 20 I = 1, NTIM
               NI = NF + 1
               NF = NF + NCOL
               WRITE (IOUT,1000) (R*A(KK),KK = NI,NF)
   20       CONTINUE
         ENDIF
         IRES = MOD(K,NCOL)
         IF ( IRES .GE. 1 ) THEN
            NI = NF + 1
            NF = NF + IRES
            WRITE (IOUT,1000) (R*A(KK),KK = NI,NF)
         ENDIF
c        WRITE (IOUT,1010)
   40 CONTINUE
      RETURN
*
c1000 FORMAT (7G16.7)
c1000 FORMAT (7F16.8)
 1000 FORMAT (15f8.3)
 1010 FORMAT (/)
      END
      SUBROUTINE WRONSK (NC,NOP,F,FP,I0M,PRWR,EPS,ET,ERRMAX)
      IMPLICIT INTEGER (A-Z)
      REAL*8 F,FP,EPS,ZERO,ONE,SUM,TSUM,ET(NC),FMAX,EE,ERRMAX,max
      common /IE/ EE,IERR
      real*8 scent,ryev,SKJ
      common /cent/ scent,ryev
      LOGICAL PRWR
      PARAMETER ( ZERO=0.0D0, ONE=1d0)
      COMMON /IO/ IIN,IOUT
      DIMENSION F(NC,NC,2),FP(NC,NC,2)
*
*     CHECK MULTICHANNEL WRONSKIAN RELATIONS
*
	SKJ = sqrt(EE/ryev)
	NINC = NC
	NINC = NOP
      ERRMAX = 0.0
      TSUM = ZERO
      DO 100 I0 = 1, I0M
         IF (I0 .EQ. 2) TSUM = ONE
         IF (PRWR) WRITE (IOUT,1000) I0,EE
         DO 90 J1 = 1, NINC
            DO 80 J2 = 1, NINC
		SKJ = abs(ET(J1)*ET(J2)) ** 0.25d0
               SUM = ZERO
               FMAX = ZERO
               IF (J1 .EQ. J2 .AND. J1 .LE. NOP) SUM = - TSUM
               DO 70 I = 1, NINC
                  SUM = SUM + (FP(I,J1,1) * F(I,J2,I0) - F(I,J1,1) *
     X                 FP(I,J2,I0))/SKJ
                  FMAX = max(FMAX,abs(FP(I,J1,1)*F(I,J2,I0)),
     X                            F(I,J1,1)**2,F(I,J2,I0)**2,
     X                            abs(F(I,J1,1)*FP(I,J2,I0)))
   70          CONTINUE
               if(FMAX.ne.0d0) ERRMAX = max(ERRMAX, abs(SUM)/FMAX)
               IF ( abs(SUM)/(FMAX+1d-100) .GT. EPS*1.0 ) 
c    X               WRITE (IOUT,1010) EE,I0,J1,J2,SUM,FMAX
     X               WRITE (44,1011) I0,J1,J2,SUM,FMAX
               IF (PRWR) WRITE (IOUT,1020) J1,J2,SUM
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
                        WRITE(44,1030) EE,ERRMAX
      IF(ERRMAX.gt.EPS) WRITE(IOUT,1040) ERRMAX
c                       WRITE(IOUT,1040) ERRMAX
      RETURN
*
 1000 FORMAT (' MULTICHANNEL WRONSKIAN RELATIONS : I0 =',I3,' E =',
     X        F10.5)
 1010 FORMAT (' E =',F10.5,' I0 =',I3,' I1 =',I3,' I2 =',I3,
     X        ' WRONSKIAN =',1P,D12.3,' / ',D12.3)
 1011 FORMAT (' I0,1,2 =',3I3,' Wronsk =',1P,D12.3,' / ',D12.3)
 1020 FORMAT (' I1 =',I3,' I2 =',I3,' WRONSKIAN =',1P,D12.3)
 1030 FORMAT (40X,'MAX WR ERROR at',f10.5,' is',1p,D12.3)
 1040 FORMAT (40X,'MAX WR ERROR:',1p,D12.3)
      END
